;=====================================================================================================
; Project: LAmaNetwork
Global LAMA_Version$="LamaNet V.1.06"
; Date: 16.January 2010 - 16.April 2010
; Author: Ringshofer Christian - Chrise
; Email: miesechrise@yahoo.de
; Copyright: Ringshofer Christian
; Description:  	This is the LAmaNetwork-userlib which allows you
;					to create a network-game as easy as possible.
;					there are functions for sending (even normal files),
;					kicking,banning,chatting, etc.
;					There are also functions which allow you to create and edit servers,
;					and of course functions for finding or joining them.
;					Try it and you will see how easy it is!
; Sources of Information: http://www.blitzforum.de/forum/viewtopic.php?t=28519&highlight=broadcast
; Thanks to: Eingeproggt,BadDeath,Nicdel,Bladerunner,Gindas(Wolfgang.Burger),Spinkser(Benjamin.Kaiser),KriD(Dirk.???)
;
; Special Thanks to:
;	Eingeproggt - better documentation
;	Oraclefile -
;	BlitzForum - assisting me everytime I had any questions!
;	BlitzBasicPortal - see above ;-)
;	KriD - for assisting me at the alpha-tests of "LAmaNetwork", testing them and his big patience!
;	Toeb - beta-tests, great inspiration and tricks.
;=====================================================================================================
;GREAT-SPECIAl-TANKS-TO: ORACLEFILE-THANKS-FOR-THE-POSSIBILTY-TAT-LAMANET-COULD-GO-ONLINE!
;PLEASE-VISIT: www.oraclefile.com !!!
;=====================================================================================================

;intern
Const LAMA_MaxCharacters=30
;host-client-abhaengige-variablen
Const LAMA_Host%=1
Const LAMA_Client%=2
;allgemeine-variablen
Global LAMA_Mode%
Global LAMA_Connection%
Global LAMA_PingMS%
Global LAMA_PingIntervall%=500
Const LAMA_TimeOut%=5000
;Events-und-nachrichten
Global LAMA_MsgID%
Global LAMA_From%
Global LAMA_EventID%
Global LAMA_EventGadgetID%
Global LAMA_EventPlayerID%
Global LAMA_EventInfo$
;count-variablen
Global LAMA_CountServers%
Global LAMA_CountMS%
Global LAMA_Counting%
Dim LAMA_CountServerIP%(0)
Dim LAMA_CountServerPort%(0)
Dim LAMA_CountServerPing%(0)
Dim LAMA_CountServerCode%(0)
Dim LAMA_CountServerName$(0)
Dim LAMA_CountServerLocked%(0)
Dim LAMA_CountServerPlayers%(0)
Dim LAMA_CountServerPassword%(0)
Dim LAMA_CountServerMaxPlayers%(0)
Dim LAMA_CountServerBannedFrom%(0)
Dim LAMA_CountServerPublisher$(0)
Dim LAMA_CountServerInformation%(0)
;internet-server-details
Global LAMA_MasterServerStream%
Global LAMA_MasterServerDetail$
Global LAMA_MasterServerPort%=80
Global LAMA_InternetTimeOut%=60000
Global LAMA_InternetPingTime%=2000
Global LAMA_InternetMS%
Global LAMA_Internet%
Global LAMA_Network%
;server-details
Global LAMA_ServerID%
Global LAMA_ServerIP%
Global LAMA_ServerPort%=8000
Global LAMA_ServerName$
Global LAMA_ServerCode%
Global LAMA_ServerStream%
Global LAMA_ServerPlayers%
Global LAMA_ServerMaxPlayers%
Global LAMA_HostServerLocked%
Global LAMA_DefaultStream%
Global LAMA_MaxServers%
Global LAMA_ServerPassCode$
Dim LAMA_ServerInfo$(9)
;sende-variablen
Global LAMA_SendMsgID%
Global LAMA_SendPlayerID%
Global LAMA_SendSecure%
Global LAMA_Sent%

Global LAMA_PackageSize%=1024
Global LAMA_GadgetID%

Global LAMA_FileName$
Global LAMA_FileEnding$
Global LAMA_FileSize%
Global LAMA_FilePath$

Global LAMA_CountTransfers%
Dim LAMA_TransferMode(0)
Dim LAMA_TransferName$(0)
Dim LAMA_TransferEnding$(0)
Dim LAMA_TransferFileName$(0)
Dim LAMA_TransferPath$(0)
Dim LAMA_TransferSize%(0)
Dim LAMA_TransferProgress#(0)
Dim LAMA_TransferHandle%(0)

Const LAMA_TransferTimeOut%=5000
Global LAMA_Transfer_Index%

Global LAMA_SecureTrys%=10
Global LAMA_SecureIndex%
Const LAMA_SecureTimeOut%=1000

;spieler-werte
Dim LAMA_Player%(0)
Dim LAMA_PlayerMessage$(0)
Dim LAMA_Player%(0)
Dim LAMA_PlayerIP%(0)
Dim LAMA_PlayerMS%(0)
Dim LAMA_PlayerPing%(0)
Dim LAMA_PlayerPort%(0)
Dim LAMA_PlayerPing%(0)
Dim LAMA_PlayerName$(0)
Dim LAMA_PlayerStream%(0)
Dim LAMA_PlayerOnline%(0)
Dim LAMA_PlayerPingOK%(0)
Dim LAMA_PlayerMSAnswer%(0)
;Master-und-count-werte
Global LAMA_MasterID%
Global LAMA_MasterMessage$
;Ip-berechnung
Dim LAMA_IP%(0)
Dim LAMA_DotIP$(0)
Dim LAMA_BroadCastIP%(0)
Global LAMA_BroadCastIPs%
Global LAMA_Path$



;bedingungswerte
Const LAMA_Banned%=4
Const LAMA_CanceledTransfer%=28
Const LAMA_Connected%=29
Const LAMA_CountRequest%=11
Const LAMA_Hosted%=24
Const LAMA_JoinDenied%=18
Const LAMA_Joined%=15
Const LAMA_JoinRequest%=17
Const LAMA_JoinTimeOut%=19
Const LAMA_Kicked%=2
Const LAMA_NameExists%=25
Const LAMA_NewPlayer%=1
Const LAMA_PlayerBanned%=5
Const LAMA_PlayerBlocked%=16
Const LAMA_PlayerCanceledTransfer%=27
Const LAMA_PlayerKicked%=3
Const LAMA_PlayerLeft%=8
Const LAMA_PlayerRenamed%=13
Const LAMA_ReceivedBank%=21
Const LAMA_ReceivedFile%=20
Const LAMA_ServerChangedInformation%=26
Const LAMA_ServerFull%=7
Const LAMA_ServerLeft%=9
Const LAMA_ServerRenamed%=14
Const LAMA_ServerStillLocked%=12
Const LAMA_StillBanned%=6
Const LAMA_TransferFailed%=23
Const LAMA_TransmittedFile%=22
Const LAMA_WrongPassword%=10

;sende-vorgang
Function LAMA_Recv%()
	
	
	
	If First LAMA_RecvMsg<>Null Or First LAMA_Gadget<>Null Then
		;variablen-vorbereiten
		Local LAMA_Gadget.LAMA_Gadget=First LAMA_Gadget
		Local LAMA_RecvMsg.LAMA_RecvMsg=First LAMA_RecvMsg
		;funktions-anfang
		If First LAMA_RecvMsg=Null Then
			LAMA_MsgID%=0
			LAMA_From%=0
		Else
			LAMA_MsgID%=LAMA_RecvMsg\MsgID
			LAMA_From%=LAMA_RecvMsg\FromID
		EndIf
		If First LAMA_Gadget=Null Then
			LAMA_GadgetID%=0
			LAMA_FileName$=""
			LAMA_FileEnding$=""
			LAMA_FileSize%=0
			LAMA_FilePath$=""
		Else
			LAMA_GadgetID%=LAMA_Gadget\GadgetID%
			LAMA_FileName$=LAMA_Gadget\Name$
			LAMA_FileEnding$=LAMA_Gadget\Ending$
			LAMA_FileSize%=LAMA_Gadget\Bytes%
			LAMA_FilePath$=LAMA_Gadget\Path$
		EndIf
		Return 1
	Else
		Return 0
	EndIf
	
	
	
End Function
Function LAMA_Read$()
	
	
	;variablen-vorbereiten
	If First LAMA_RecvMsg<>Null Then
		Local LAMA_RecvMsg.LAMA_RecvMsg=First LAMA_RecvMsg
		
		LAMA_From%=LAMA_RecvMsg\FromID
		LAMA_MsgID%=LAMA_RecvMsg\MsgID
		Local LAMA_Value$=LAMA_RecvMsg\Value
		Delete LAMA_RecvMsg.LAMA_RecvMsg
		;rueckgabe-wert
		Return LAMA_Value$
	EndIf
	
	
	
End Function
Function LAMA_ReadBank%(RefreshBank%=0)
	
	Local LAMA_Gadget.LAMA_Gadget=First LAMA_Gadget
	If LAMA_Gadget.LAMA_Gadget<>Null Then
		If RefreshBank%=0 Then
			LAMA_Gadget\Bank=CreateBank(LAMA_Gadget\Bytes)
			Delete LAMA_Gadget.LAMA_Gadget
			Return LAMA_Gadget\Bank
		Else
			Local i
			ResizeBank(RefreshBank,BankSize(LAMA_Gadget\Bank))
			For i=1 To LAMA_Gadget\Bytes
				PokeByte(RefreshBank,i-1,PeekByte(LAMA_Gadget\Bank,i-1))
			Next
			Delete LAMA_Gadget.LAMA_Gadget
			Return 1
		EndIf
	EndIf
	
End Function
Function LAMA_ReadFile%()
	
	Local LAMA_Gadget.LAMA_Gadget=First LAMA_Gadget
	If LAMA_Gadget.LAMA_Gadget<>Null Then
		
		LAMA_FileName=LAMA_Gadget\Name$
		LAMA_FileEnding=LAMA_Gadget\Ending$
		LAMA_FileSize=LAMA_Gadget\Bytes%
		LAMA_FilePath=LAMA_Gadget\Path$
		
		Delete LAMA_Gadget.LAMA_Gadget
		Return 1
	EndIf
	
End Function

Function LAMA_NewBlock()
	
	If Last LAMA_NormalSend<>Null Then
		Local LAMA_NormalSend.LAMA_NormalSend=Last LAMA_NormalSend
		If LAMA_NormalSend\Tail<2 Then LAMA_NormalSend\Tail=LAMA_NormalSend\Tail+2
	EndIf
	If Last LAMA_SecureSend<>Null Then
		Local LAMA_SecureSend.LAMA_SecureSend=Last LAMA_SecureSend
		If LAMA_SecureSend\Tail<2 Then LAMA_SecureSend\Tail=LAMA_SecureSend\Tail+2
	EndIf
	LAMA_Sent%=False
	
End Function
Function LAMA_SetPackageSize(Size=1024)
	If Size<1 Then Size=1
	LAMA_PackageSize%=Size
End Function
Function LAMA_SendFile(PlayerID%=0,GadgetID%=0,Path$)
	
	Local LAMA_Transfer.LAMA_Transfer,LAMA_ID%
	If LAMA_Connection% Then
		LAMA_FileInformation(Path$)
		If PlayerID%>0 And PlayerID%<>LAMA_MasterID% Then;an-einen-spieler-schicken
			If LAMA_PlayerOnline(PlayerID%-1) Then
				LAMA_Transfer.LAMA_Transfer=New LAMA_Transfer
				LAMA_Transfer\ID=PlayerID%
				LAMA_Transfer\GadgetID%=GadgetID%
				LAMA_Transfer\Bytes=FileSize(Path$)
				LAMA_Transfer\File=ReadFile(Path$)
				LAMA_Transfer\FileID=Str(LAMA_MasterID)+Str(LAMA_Transfer_Index%)
				LAMA_Transfer_Index%=(LAMA_Transfer_Index%+1) Mod 65536
				LAMA_Transfer\Name$=LAMA_FileName
				LAMA_Transfer\Ending$=LAMA_FileEnding
				LAMA_Transfer\SendOrRecv=1
				LAMA_Transfer\MS%=MilliSecs()+LAMA_TransferTimeOut%
				LAMA_Transfer\SendAccess=True
				If LAMA_Transfer\File=0 Then
					Delete LAMA_Transfer.LAMA_Transfer
					Return 0
				EndIf
			EndIf
		ElseIf PlayerID%=0 Then;an-alle-spieler-senden
			For LAMA_ID%=1 To LAMA_ServerMaxPlayers
				If LAMA_PlayerOnline(LAMA_ID%-1)=True And LAMA_ID%<>LAMA_MasterID% Then
					LAMA_Transfer.LAMA_Transfer=New LAMA_Transfer
					LAMA_Transfer\ID=LAMA_ID%
					LAMA_Transfer\GadgetID%=GadgetID%
					LAMA_Transfer\Bytes=FileSize(Path$)
					LAMA_Transfer\File=ReadFile(Path$)
					LAMA_Transfer\FileID=Str(LAMA_MasterID)+Str(LAMA_Transfer_Index%)
					LAMA_Transfer_Index%=(LAMA_Transfer_Index%+1) Mod 65536
					LAMA_Transfer\Name$=LAMA_FileName
					LAMA_Transfer\Ending$=LAMA_FileEnding
					LAMA_Transfer\SendOrRecv=1
					LAMA_Transfer\MS%=MilliSecs()+LAMA_TransferTimeOut%
					LAMA_Transfer\SendAccess=True
					If LAMA_Transfer\File=0 Then
						Delete LAMA_Transfer.LAMA_Transfer
						Return 0
					EndIf
				EndIf
			Next
		EndIf
		Return 1
	EndIf
	
End Function
Function LAMA_SendBank(PlayerID%=0,BankID%,Bank%)
	
	Local i
	If LAMA_Connection% Then
		If PlayerID%>0 And PlayerID%<>LAMA_MasterID% Then
			WriteByte(LAMA_ServerStream%,242);send-bank
			WriteInt(LAMA_ServerStream%,BankID%)
			WriteInt(LAMA_ServerStream%,BankSize(Bank))
			For i=1 To BankSize(Bank)
				WriteByte(LAMA_ServerStream%,PeekByte(Bank,i-1))
			Next
			SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP%(PlayerID%-1),LAMA_PlayerPort%(PlayerID%-1))
		ElseIf PlayerID%=0 Then
			Local LAMA_ID%
			For LAMA_ID%=1 To LAMA_ServerMaxPlayers
				WriteByte(LAMA_ServerStream%,242);send-bank
				WriteInt(LAMA_ServerStream%,BankID%)
				WriteInt(LAMA_ServerStream%,BankSize(Bank))
				For i=1 To BankSize(Bank)
					WriteByte(LAMA_ServerStream%,PeekByte(Bank,i-1))
				Next
				SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP%(LAMA_ID%-1),LAMA_PlayerPort%(LAMA_ID%-1))
			Next
		EndIf
	EndIf
	
End Function

Function LAMA_Send(PlayerID%=0,MsgID%,Value$,Secure%=0)
	
	
	If PlayerID%<>LAMA_MasterID Then
		;variablen-vorbereiten
		Local LAMA_Start=0
		Local LAMA_NormalSend.LAMA_NormalSend
		Local LAMA_SecureSend.LAMA_SecureSend
		If Secure%<0 Then Secure%=0
		If Secure%>1 Then Secure%=1
		;funktionswerte-bearbeiten
		If MsgID%<1 Then MsgID=1
		If LAMA_Sent%=True Then
			If LAMA_SendMsgID%<>MsgID% Or LAMA_SendPlayerID%<>PlayerID% Or LAMA_SendSecure%<>Secure% Then
				If Last LAMA_NormalSend<>Null Then
					LAMA_NormalSend.LAMA_NormalSend=Last LAMA_NormalSend
					If LAMA_NormalSend\Tail<2 Then LAMA_NormalSend\Tail=LAMA_NormalSend\Tail+2
				EndIf
				If Last LAMA_SecureSend<>Null Then
					LAMA_SecureSend.LAMA_SecureSend=Last LAMA_SecureSend
					If LAMA_SecureSend\Tail<2 Then LAMA_SecureSend\Tail=LAMA_SecureSend\Tail+2
				EndIf
				LAMA_Start=1
			EndIf
		Else
			LAMA_Start=1
		EndIf
		;sende-werte-zwischenspeichern
		If Secure%=0 Or (Secure%=1 And PlayerID<>0) Then
			LAMA_NormalSend.LAMA_NormalSend=New LAMA_NormalSend
			LAMA_NormalSend\ID=PlayerID
			LAMA_NormalSend\MsgID=MsgID
			LAMA_NormalSend\Value=Value
			LAMA_NormalSend\Tail=LAMA_Start
			If Secure=1 Then
				LAMA_NormalSend\Secure=1
				LAMA_NormalSend\SendAccess=True
				If LAMA_Start=1 Then
					LAMA_SecureIndex%=(LAMA_SecureIndex%+1) Mod 65536
					LAMA_NormalSend\MS=MilliSecs()+LAMA_SecureTimeOut%
				EndIf
				LAMA_NormalSend\SecureID=LAMA_SecureIndex%
			EndIf
		Else;sichere-uebertragung-auf-alle-spieler!
			LAMA_SecureSend.LAMA_SecureSend=New LAMA_SecureSend
			LAMA_SecureSend\MsgID=MsgID
			LAMA_SecureSend\Value=Value
			LAMA_SecureSend\Tail=LAMA_Start
		EndIf
		;sende-werte-uebergeben
		LAMA_SendMsgID%=MsgID%
		LAMA_SendPlayerID%=PlayerID%
		LAMA_SendSecure%=Secure%
		LAMA_Sent%=True
	EndIf
	
	
End Function
Function LAMA_CancelTransfer(TransferID%)
	
	Local LAMA_Transfer.LAMA_Transfer=Object.LAMA_Transfer(LAMA_TransferHandle(TransferID%))
	If LAMA_Transfer<>Null Then
		WriteByte(LAMA_ServerStream%,219);file-transfer-message
		WriteInt(LAMA_ServerStream%,LAMA_MasterID);MasterID-gesendet von
		WriteInt(LAMA_ServerStream%,LAMA_Transfer\ID);senden an
		WriteInt(LAMA_ServerStream%,LAMA_Transfer\FileID);FileID
		CloseFile LAMA_Transfer\File
		
		;neues-event-erstellen
		Local LAMA.LAMA_GetEvent=New LAMA_GetEvent
		LAMA\ID%=LAMA_CanceledTransfer%
		LAMA\Info=LAMA_Transfer\Name+"."+LAMA_Transfer\Ending
		
		Delete LAMA_Transfer.LAMA_Transfer
	EndIf
	
End Function

Function LAMA_BanPlayer(PlayerID%,BanReason$,BanTime_Seconds%=0,BanTime_Minutes%=0,BanTime_Hours%=0);Bannzeit in Sekunden
	
	
	If LAMA_PlayerOnline(PlayerID%-1) Then
		;variablen-vorbereiten
		Local LAMA_ID%,LAMA.LAMA_GetEvent,BanList
		;bann-liste-erneuern
		Local LAMA_Ban.LAMA_BanList=New LAMA_BanList
		LAMA_Ban\IP%=LAMA_PlayerIP%(PlayerID%-1)
		;zeit-berechnen
		If BanTime_Seconds%+BanTime_Minutes%+BanTime_Hours%<>0 Then;bann-auf-bestimmte-zeit
			Local MaxMS%=1000*BanTime_Seconds%+60000*BanTime_Minutes%+3600000*BanTime_Hours%
			LAMA_Ban\MS%=MilliSecs()+MaxMS%
		Else;ip-bann-auf-ewig
			Select FileType("LAMA_BanList.dat")
				Case 1
					BanList=OpenFile("LAMA_BanList.dat")
					SeekFile BanList,FileSize(BanList)
					WriteString BanList,DottedIP$(LAMA_PlayerIP(PlayerID%-1))
					CloseFile BanList
				Case 0
					BanList=WriteFile("LAMA_BanList.dat")
					SeekFile BanList,FileSize("LAMA_BanList.dat")
					WriteString BanList,DottedIP$(LAMA_PlayerIP(PlayerID%-1))
					CloseFile BanList
			End Select
		EndIf
		WriteByte(LAMA_ServerStream%,8)
		WriteString(LAMA_ServerStream%,BanReason$)
		SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP%(PlayerID%-1),LAMA_PlayerPort%(PlayerID%-1))
		;infos-zum-spieler-bann-an-alle-anderen-schicken
		For LAMA_ID%=1 To LAMA_ServerMaxPlayers%
			If LAMA_PlayerOnline%(LAMA_ID%-1)=1 And LAMA_ID%<>LAMA_MasterID Then
				WriteByte(LAMA_ServerStream%,9);kick-9
				WriteInt(LAMA_ServerStream%,PlayerID%)
				WriteInt(LAMA_ServerStream%,MaxMS%)
				
				SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP%(LAMA_ID%-1),LAMA_PlayerPort%(LAMA_ID%-1))
			EndIf
		Next
		;spieler-kicken
		LAMA_KickPlayer(PlayerID%)
		LAMA.LAMA_GetEvent=Last LAMA_GetEvent
		Delete LAMA.LAMA_GetEvent
		;neues-event-erstellen
		LAMA.LAMA_GetEvent=New LAMA_GetEvent
		LAMA\ID%=LAMA_PlayerBanned%
		LAMA\PlayerID%=PlayerID%
	EndIf
	
	
End Function
Function LAMA_KickPlayer(PlayerID%)
	
	
	If LAMA_PlayerOnline(PlayerID%-1) Then
		;variablen-vorbereiten
		Local LAMA_ID%,LAMA.LAMA_GetEvent
		;spieler-loeschen-udp-stream-schliessen-etc
		WriteByte(LAMA_ServerStream%,6)
		SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP%(PlayerID%-1),LAMA_PlayerPort%(PlayerID%-1))
		;If LAMA_PlayerStream%(PlayerID%-1)>0 Then CloseUDPStream LAMA_PlayerStream%(PlayerID%-1):LAMA_PlayerStream%(PlayerID%-1)=0
		LAMA_PlayerOnline%(PlayerID%-1)=0
		LAMA_PlayerStream%(PlayerID%-1)=0
		LAMA_PlayerPingOK%(PlayerID%-1)=0
		LAMA_PlayerPing%(PlayerID%-1)=0
		LAMA_PlayerMS%(PlayerID%-1)=0
		LAMA_ServerPlayers%=LAMA_ServerPlayers%-1
		;infos-zum-spieler-kick-an-alle-anderen-schicken
		For LAMA_ID%=1 To LAMA_ServerMaxPlayers%
			If LAMA_PlayerOnline%(LAMA_ID%-1)=1 And LAMA_ID%<>LAMA_MasterID Then
				WriteByte(LAMA_ServerStream%,7);kick-7
				WriteInt(LAMA_ServerStream%,PlayerID%)
				SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP%(LAMA_ID%-1),LAMA_PlayerPort%(LAMA_ID%-1))
			EndIf
		Next
		;neues-event-erstellen
		LAMA.LAMA_GetEvent=New LAMA_GetEvent
		LAMA\ID%=LAMA_PlayerKicked%
		LAMA\PlayerID%=PlayerID%
		;neues-event-erstellen
		LAMA.LAMA_GetEvent=New LAMA_GetEvent
		LAMA\ID%=LAMA_PlayerLeft%
		LAMA\PlayerID%=PlayerID%
	EndIf
	
	
End Function

;spieler-funktionen
Function LAMA_RenamePlayer(PlayerID%,Name$)
	Name$=Left(Name$,LAMA_MaxCharacters)
	LAMA_PlayerName$(LAMA_MasterID-1)=Name$
	Local LAMA_ID%
	Select LAMA_Mode%
		Case LAMA_Host%
			For LAMA_ID%=1 To LAMA_ServerMaxPlayers%
				If LAMA_PlayerOnline%(LAMA_ID%-1)=1 And LAMA_ID%<>LAMA_MasterID Then
					WriteByte(LAMA_ServerStream%,12)
					WriteInt(LAMA_ServerStream%,PlayerID%)
					WriteString(LAMA_ServerStream%,Name$)
					SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP%(LAMA_ID%-1),LAMA_PlayerPort%(LAMA_ID%-1))
				EndIf
			Next
		Case LAMA_Client%
			WriteByte(LAMA_ServerStream%,12)
			WriteInt(LAMA_ServerStream%,LAMA_MasterID)
			WriteString(LAMA_ServerStream%,Name$)
			SendUDPMsg(LAMA_ServerStream%,LAMA_ServerIP%,LAMA_ServerPort%)
	End Select
End Function
Function LAMA_Name$(PlayerID%)
	Return LAMA_PlayerName$(PlayerID%-1)
End Function
Function LAMA_Online%(PlayerID%)
	Return LAMA_PlayerOnline%(PlayerID%-1)
End Function
Function LAMA_Ping%(PlayerID%)
	Return LAMA_PlayerPing%(PlayerID%-1)
End Function
Function LAMA_ServerID%()
	Return LAMA_ServerID%
End Function

;event-funtkionen
Function LAMA_Event%()
	Local LAMA.LAMA_GetEvent=First LAMA_GetEvent
	If LAMA.LAMA_GetEvent<>Null Then
		LAMA_EventID%=LAMA\ID%
		LAMA_EventGadgetID%=LAMA\GadgetID%
		LAMA_EventPlayerID%=LAMA\PlayerID%
		LAMA_EventInfo$=LAMA\Info$
		Delete LAMA.LAMA_GetEvent
		Return 1
	Else
		LAMA_EventID%=0
		LAMA_EventGadgetID%=0
		LAMA_EventPlayerID%=0
	EndIf
End Function
Function LAMA_ClearEvents%()
	Local LAMA.LAMA_GetEvent
	For LAMA.LAMA_GetEvent=Each LAMA_GetEvent
		Delete LAMA.LAMA_GetEvent
	Next
End Function

;server-funktionen
Function LAMA_InitServer%(Adress$)
	LAMA_Internet%=True
	LAMA_MasterServerDetail$=Adress$
	TCPTimeouts LAMA_TimeOut%,LAMA_TimeOut%
End Function
Function LAMA_DeInitServer%()
	LAMA_Internet%=False
	LAMA_MasterServerDetail$=""
End Function

Function LAMA_SetPort%(Port%=8000)
	LAMA_ServerPort%=8000
End Function
Function LAMA_HostServer%(ServerName$="LAmaNet",MaxPlayers%=10,Name$="Lama",ServerPassword$="")
	
	
	If LAMA_Connection%=0 And MaxPlayers%>1 Then
		;variablen-vorbereiten
		Local i
		LAMA_ServerPassCode$=LAMA_EnCode$(ServerPassword$)
		ServerName$=Left(ServerName$,LAMA_MaxCharacters)
		Name$=Left(Name$,LAMA_MaxCharacters)
		;UDP-stream-erstellen
		LAMA_ServerStream%=CreateUDPStream(LAMA_ServerPort%)
		LAMA_DefaultStream%=CreateUDPStream(LAMA_ServerPort%+1)
		;wenn-stream-erstellen-erfolgreich
		If LAMA_ServerStream%>0 And LAMA_DefaultStream%>0 Then
			LAMA_ServerCode%=Rand(0,1000000000)
			;Variablen-vorbereiten
			LAMA_ServerMaxPlayers%=MaxPlayers%
			;dim-feld-vorbereiten
			Dim LAMA_PlayerMSAnswer%(LAMA_ServerMaxPlayers%-1)
			Dim LAMA_PlayerMessage$(LAMA_ServerMaxPlayers%-1)
			Dim LAMA_PlayerPingOK%(LAMA_ServerMaxPlayers%-1)
			Dim LAMA_PlayerStream%(LAMA_ServerMaxPlayers%-1)
			Dim LAMA_PlayerOnline%(LAMA_ServerMaxPlayers%-1)
			Dim LAMA_PlayerPing%(LAMA_ServerMaxPlayers%-1)
			Dim LAMA_PlayerPort%(LAMA_ServerMaxPlayers%-1)
			Dim LAMA_PlayerName$(LAMA_ServerMaxPlayers%-1)
			Dim LAMA_PlayerPort%(LAMA_ServerMaxPlayers%-1)
			Dim LAMA_PlayerIP%(LAMA_ServerMaxPlayers%-1)
			Dim LAMA_PlayerMS%(LAMA_ServerMaxPlayers%-1)
			;server-type-bearbeiten
			LAMA_ServerIP%=UDPStreamIP(LAMA_ServerStream%)
			LAMA_ServerPlayers%=LAMA_ServerPlayers%+1
			LAMA_ServerMaxPlayers%=MaxPlayers%
			LAMA_ServerName$=ServerName$
			LAMA_Mode=LAMA_Host
			;player-erstellen
			LAMA_MasterID=1
			LAMA_ServerID%=LAMA_MasterID
			LAMA_PlayerName$(LAMA_MasterID-1)=Name$
			LAMA_PlayerOnline%(LAMA_MasterID-1)=1
			;nur-wenn-internet-verbindung-aktiviert-wurde!
			If LAMA_Internet Then
				;TCPTimeouts LAMA_InternetTimeOut%,0
				LAMA_MasterServerStream=OpenTCPStream(LAMA_MasterServerDetail,LAMA_MasterServerPort)
				If LAMA_MasterServerStream<>0 Then
					Local Pass
					If LAMA_ServerPassCode$<>"" Then Pass=1 Else Pass=0
					WriteLine LAMA_MasterServerStream,"POST /Lama/AddServer.php HTTP/1.1" 
					WriteLine LAMA_MasterServerStream,"Host: "+LAMA_MasterServerDetail$
					WriteLine LAMA_MasterServerStream,"User-Agent: LamaNet"
					Local Command$=""
					Command$=Command$+"Port="+LAMA_ServerPort%
					Command$=Command$+"&Servername="+LAMA_ServerName$
					Command$=Command$+"&Players="+LAMA_ServerPlayers%
					Command$=Command$+"&MaxPlayers="+LAMA_ServerMaxPlayers%
					Command$=Command$+"&ServerLocked="+LAMA_ServerLocked%
					Command$=Command$+"&Password="+Pass%
					Command$=Command$+"&Playername="+LAMA_PlayerName$(LAMA_MasterID-1)
					For i=0 To 0
						Command$=Command$+"&Information"+Str(i+1)+"="+LAMA_ServerInfo$(i)
					Next
					WriteLine LAMA_MasterServerStream,"Content-Type: application/x-www-form-urlencoded" 
					WriteLine LAMA_MasterServerStream,"Content-Length: "+Len(Command$)
					
					WriteLine LAMA_MasterServerStream,"Keep-Alive: 115"
					WriteLine LAMA_MasterServerStream,"Connection: keep-alive"
					WriteLine LAMA_MasterServerStream,"Cache-Control: no-cache"
					WriteLine LAMA_MasterServerStream,""
					WriteLine LAMA_MasterServerStream,Command$
					
					;CloseTCPStream(LAMA_MasterServerStream)
					;LAMA_MasterServerStream=0
				Else
					CloseUDPStream(LAMA_ServerStream%)
					CloseUDPStream(LAMA_DefaultStream%)
					LAMA_ServerStream%=0
					LAMA_DefaultStream%=0
					Return 0;wenn-server-nicht-erstellt-werden-konnte
				EndIf
			EndIf
			;verbindund-herstellen
			LAMA_Connection%=True
			;neues-event-erstellen
			Local LAMA.LAMA_GetEvent=New LAMA_GetEvent
			LAMA\ID%=LAMA_Hosted%
			LAMA\PlayerID%=LAMA_MasterID%
			;neues-event-erstellen
			LAMA.LAMA_GetEvent=New LAMA_GetEvent
			LAMA\ID%=LAMA_Connected%
			LAMA\PlayerID%=LAMA_MasterID%
			
			Return 1;wenn-stream-erstellen-erfolgreich	
		Else
			LAMA_ServerStream%=0
			LAMA_DefaultStream%=0
			Return 0;wenn-server-nicht-erstellt-werden-konnte
		EndIf
	EndIf
	
	
	
End Function
Function LAMA_JoinServer%(Server%,Name$="Lama",Password$="",MaxPing%=1000)
	
	
	;Variablen-vorbereiten
	Name$=Left(Name$,LAMA_MaxCharacters)
	Local LAMA.LAMA_GetEvent
	Local LAMA_ID%,LAMA_Tag,LAMA_Joined%
	;UDP-stream-erstellen
	LAMA_ServerStream%=CreateUDPStream()
	;wenn-stream-erstellen-erfolgreich
	If LAMA_ServerStream%<>0 Then
		;Anfrage-via-ServerIP-senden
		WriteByte(LAMA_ServerStream%,2)
		WriteString(LAMA_ServerStream%,Password$)
		WriteString(LAMA_ServerStream%,Name$)
		SendUDPMsg(LAMA_ServerStream%,LAMA_CountServerIP%(Server%-1),LAMA_ServerPort%)
		;dim-felder-vorbereiten
		LAMA_ServerMaxPlayers%=LAMA_CountServerMaxPlayers%(Server%-1)
		Dim LAMA_PlayerMSAnswer%(LAMA_ServerMaxPlayers%-1)
		Dim LAMA_PlayerMessage$(LAMA_ServerMaxPlayers%-1)
		Dim LAMA_PlayerPingOK%(LAMA_ServerMaxPlayers%-1)
		Dim LAMA_PlayerOnline%(LAMA_ServerMaxPlayers%-1)
		Dim LAMA_PlayerName$(LAMA_ServerMaxPlayers%-1)
		Dim LAMA_PlayerPing%(LAMA_ServerMaxPlayers%-1)
		Dim LAMA_PlayerPort%(LAMA_ServerMaxPlayers%-1)
		Dim LAMA_PlayerIP%(LAMA_ServerMaxPlayers%-1)
		Dim LAMA_Player%(LAMA_ServerMaxPlayers%-1)
		Dim LAMA_PlayerMS%(LAMA_ServerMaxPlayers%-1)
		;daten-uebergeben
		LAMA_ServerIP%=LAMA_CountServerIP%(Server%-1)
		LAMA_ServerName$=LAMA_CountServerName$(Server%-1)
		LAMA_ServerPlayers%=LAMA_CountServerPlayers%(Server%-1)
		LAMA_ServerMaxPlayers%=LAMA_CountServerMaxPlayers%(Server%-1)
		;Millisekunden-speichern
		Local MS%=MilliSecs()+MaxPing%
		;MaxPing-Millisekunden-auf-antwort-warten
		While MS%>MilliSecs()
			;sobald-nachricht-empfangen-wurde
			While RecvUDPMsg(LAMA_ServerStream%)
				LAMA_Tag=ReadByte(LAMA_ServerStream%)
				Select LAMA_Tag
					Case 1;tag-join-verweigerung
						Local Banned%=ReadByte(LAMA_ServerStream%)
						Local NameExists%=ReadByte(LAMA_ServerStream%)
						Local LAMA_Locked%=ReadByte(LAMA_ServerStream%)
						Local LAMA_Wrong%=1-ReadByte(LAMA_ServerStream%)
						Local LAMA_Full%=ReadByte(LAMA_ServerStream%)
						If Banned%=True Then;spieler-von-server-gebannt
							;neues-event-erstellen
							LAMA.LAMA_GetEvent=New LAMA_GetEvent
							LAMA\ID%=LAMA_StillBanned%
							LAMA\PlayerID%=LAMA_MasterID
						EndIf
						If NameExists% Then;server-gesperrt
							;neues-event-erstellen
							LAMA.LAMA_GetEvent=New LAMA_GetEvent
							LAMA\ID%=LAMA_NameExists%
						EndIf
						If LAMA_Locked% Then;server-gesperrt
							;neues-event-erstellen
							LAMA.LAMA_GetEvent=New LAMA_GetEvent
							LAMA\ID%=LAMA_ServerLocked%
						EndIf
						If LAMA_Wrong% Then;falsches-passwort
							;neues-event-erstellen
							LAMA.LAMA_GetEvent=New LAMA_GetEvent
							LAMA\ID%=LAMA_WrongPassword%
						EndIf
						If LAMA_Full% Then;server-voll
							;neues-event-erstellen
							LAMA.LAMA_GetEvent=New LAMA_GetEvent
							LAMA\ID%=LAMA_ServerFull%
						EndIf
						;variablen-zuruecksetzen
						Dim LAMA_PlayerMSAnswer%(0)
						Dim LAMA_PlayerMessage$(0)
						Dim LAMA_PlayerPingOK%(0)
						Dim LAMA_PlayerOnline%(0)
						Dim LAMA_PlayerName$(0)
						Dim LAMA_PlayerPing%(0)
						Dim LAMA_PlayerPort%(0)
						Dim LAMA_PlayerIP%(0)
						Dim LAMA_Player%(0)
						Dim LAMA_PlayerMS%(0)
						;udp-streams-schliessen
						If LAMA_ServerStream%>0 Then CloseUDPStream(LAMA_ServerStream%):LAMA_ServerStream%=0
						Return 0
					Case 2
						;neuen-spieler-dazuzaehlen
						LAMA_ServerPlayers%=LAMA_ServerPlayers%+1
						
						LAMA_ServerID%=ReadInt(LAMA_ServerStream%)
						LAMA_ID%=ReadInt(LAMA_ServerStream%)
						LAMA_PlayerName$(LAMA_ID%-1)=Name$
						LAMA_PlayerOnline%(LAMA_ID%-1)=1
						LAMA_MasterID=LAMA_ID%
						;spieler-namen-auslesen
						While Not Eof(LAMA_ServerStream%)
							LAMA_ID%=ReadInt(LAMA_ServerStream%)
							LAMA_PlayerName$(LAMA_ID%-1)=ReadString(LAMA_ServerStream%)
							LAMA_PlayerOnline%(LAMA_ID%-1)=1
						Wend
						;globale-variablen-bestimmen
						LAMA_PingMS%=MilliSecs()+800
						LAMA_Mode%=LAMA_Client%
						LAMA_Connection%=True
						;server-informationen-hinzufuegen
						Local i
						Local LAMA_Info.LAMA_Information=Object.LAMA_Information(LAMA_CountServerInformation(Server%-1))
						For i=0 To 9
							LAMA_ServerInfo(i)=LAMA_Info\Information[i]
						Next
						
						;neues-event-erstellen
						LAMA.LAMA_GetEvent=New LAMA_GetEvent
						LAMA\ID%=LAMA_Joined%
						LAMA\PlayerID%=LAMA_MasterID%
						;neues-event-erstellen
						LAMA.LAMA_GetEvent=New LAMA_GetEvent
						LAMA\ID%=LAMA_Connected%
						LAMA\PlayerID%=LAMA_MasterID%
						;programm-bennenen
						;AppTitle "LAmaNet - Client      Server: "+LAMA_ServerName$
						Return 1
				End Select
			Wend
		Wend
		;neues-event-erstellen
		LAMA.LAMA_GetEvent=New LAMA_GetEvent
		LAMA\ID%=LAMA_JoinTimeOut%
		Return 0
	EndIf
	
	
End Function

Function LAMA_Update%()
	
	
	If LAMA_Connection%=True Then
		;Variablen-vorbereiten
		Local ServerCode%
		Local ServerBannedFrom%
		Local ServerPlayers%
		Local ServerPassword%
		Local ServerLocked%
		Local ServerPublisher$
		Local ServerName$
		Local ServerMaxPlayers%
		
		Local LAMA_PassCode$,LAMA.LAMA_GetEvent,LAMA_Tag%,Index%
		Local LAMA_Ban.LAMA_BanList,Banned%
		Local LAMA_NewPlayerID%,LAMA_NewPlayerName$
		Local LAMA_ID%,LAMA_ID2%,i
		Local MsgID%,Tail%,PlayerID%
		Local BanList
		
		Local LAMA_TempSecure
		Local SecureID
		;speicherwerte-zuruecksetzen
		LAMA_SendMsgID%=0
		LAMA_SendPlayerID%=0
		LAMA_SendSecure%=0
		LAMA_Sent%=0
		
		Local LAMA_VarType
		
		Local Command$
		
		;Banktransfer-funktionen
		Local LAMA_Gadget.LAMA_Gadget,LAMA_File$,FileFound%
		
		;Send-Funktion
		Local LAMA_NormalSend.LAMA_NormalSend
		Local LAMA_MultiSend.LAMA_MultiSend
		Local LAMA_RecvMsg.LAMA_RecvMsg
		
		;[Block] Filetransfer
		;FileTransfer-funktionen
		Local LAMA_Transfer.LAMA_Transfer
		Local LAMA_FileRead
		Local LAMA_Byte,LAMA_FileEnd,LAMA_Avail
		Local LAMA_PackageIndex
		
		For LAMA_Transfer.LAMA_Transfer=Each LAMA_Transfer
			If LAMA_Transfer\SendOrRecv=1 Then
				If LAMA_Transfer\SendAccess=True Then
					WriteByte(LAMA_ServerStream%,220);file-transfer-message
					WriteInt(LAMA_ServerStream%,LAMA_MasterID);MasterID-gesendet von
					WriteInt(LAMA_ServerStream%,LAMA_Transfer\ID);senden an
					If LAMA_Transfer\PackageIndex=0 Then
						WriteByte(LAMA_ServerStream%,1);transfer-anfang
						WriteString(LAMA_ServerStream%,LAMA_Transfer\Name$);FileName
						WriteString(LAMA_ServerStream%,LAMA_Transfer\Ending$);FileEnding
						WriteInt(LAMA_ServerStream%,LAMA_Transfer\FileID);FileID
						WriteInt(LAMA_ServerStream%,LAMA_Transfer\GadgetID%);GadgetID
						WriteInt(LAMA_ServerStream%,LAMA_Transfer\Bytes);Dateigre
						LAMA_Transfer\PackageIndex=1
						Select LAMA_Mode
							Case LAMA_Host
								SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP(LAMA_Transfer\ID-1),LAMA_PlayerPort(LAMA_Transfer\ID-1))
							Case LAMA_Client
								SendUDPMsg(LAMA_ServerStream%,LAMA_ServerIP,LAMA_ServerPort)
						End Select
					Else
						WriteByte(LAMA_ServerStream%,0);kein-transfer-anfang!
						WriteInt(LAMA_ServerStream%,LAMA_Transfer\PackageIndex)
						WriteInt(LAMA_ServerStream%,LAMA_Transfer\FileID)
						LAMA_Transfer\Avail=LAMA_Transfer\Bytes-FilePos(LAMA_Transfer\File)
						If LAMA_Transfer\Avail<=LAMA_PackageSize Then
							WriteByte(LAMA_ServerStream%,1);transfer-ende
							WriteShort(LAMA_ServerStream%,LAMA_Transfer\Avail);short-byte-anzahl
							For i=1 To LAMA_Transfer\Avail
								LAMA_Byte=ReadByte(LAMA_Transfer\File)
								WriteByte(LAMA_ServerStream%,LAMA_Byte);byte-filebyte
							Next
						Else
							WriteByte(LAMA_ServerStream%,0);kein-transfer-ende!
							WriteShort(LAMA_ServerStream%,LAMA_PackageSize)
							For i=1 To LAMA_PackageSize
								LAMA_Byte=ReadByte(LAMA_Transfer\File)
								WriteByte(LAMA_ServerStream%,LAMA_Byte)
							Next
						EndIf
						LAMA_Transfer\Progress=Float(FilePos(LAMA_Transfer\File))/Float(LAMA_Transfer\Bytes)
						WriteFloat(LAMA_ServerStream%,LAMA_Transfer\Progress)
						LAMA_Transfer\SendAccess=False;ACCESS=FALSE
						Select LAMA_Mode
							Case LAMA_Host
								SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP(LAMA_Transfer\ID-1),LAMA_PlayerPort(LAMA_Transfer\ID-1))
							Case LAMA_Client
								SendUDPMsg(LAMA_ServerStream%,LAMA_ServerIP,LAMA_ServerPort)
						End Select
					EndIf
				EndIf
				
				If LAMA_Transfer\Avail<=LAMA_PackageSize And LAMA_Transfer\Avail>0 Then
					;neues-event-erstellen
					LAMA.LAMA_GetEvent=New LAMA_GetEvent
					LAMA\ID%=LAMA_TransmittedFile%
					LAMA\PlayerID%=LAMA_Transfer\ID
					;datei-schliessen
					CloseFile(LAMA_Transfer\File)
					Delete LAMA_Transfer.LAMA_Transfer;datei-schliessen-und-bertragung-beenden
				ElseIf LAMA_Transfer\MS%<MilliSecs() Then
					;neues-event-erstellen
					LAMA.LAMA_GetEvent=New LAMA_GetEvent
					LAMA\ID%=LAMA_TransferFailed%
					LAMA\PlayerID%=LAMA_Transfer\ID
					;datei-schliessen-FEHLERabbruch
					CloseFile(LAMA_Transfer\File)
					Delete LAMA_Transfer.LAMA_Transfer;datei-schliessen-und-bertragung-beenden
				EndIf
			ElseIf LAMA_Transfer\SendOrRecv=2 Then
				If LAMA_Transfer\MS%-(LAMA_TransferTimeOut/2)<MilliSecs() Then
					WriteByte(LAMA_ServerStream%,229)
					WriteInt(LAMA_ServerStream%,LAMA_MasterID);MasterID-gesendet von
					WriteInt(LAMA_ServerStream%,LAMA_Transfer\ID);senden an
					WriteInt(LAMA_ServerStream%,LAMA_Transfer\FileID)
					Select LAMA_Mode
						Case LAMA_Host
							SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP(LAMA_Transfer\ID-1),LAMA_PlayerPort(LAMA_Transfer\ID-1))
						Case LAMA_Client
							SendUDPMsg(LAMA_ServerStream%,LAMA_ServerIP,LAMA_ServerPort)
					End Select
				EndIf
				If LAMA_Transfer\MS%<MilliSecs() Then
					;neues-event-erstellen
					LAMA.LAMA_GetEvent=New LAMA_GetEvent
					LAMA\ID%=LAMA_TransferFailed%
					LAMA\PlayerID%=LAMA_Transfer\ID
					;datei-schliessen
					CloseFile(LAMA_Transfer\File)
					Delete LAMA_Transfer.LAMA_Transfer;datei-schliessen-und-bertragung-beenden
				EndIf
			EndIf
			
			If LAMA_Transfer<>Null Then
				If LAMA_Transfer\MS%<MilliSecs() Then
					;neues-event-erstellen
					LAMA.LAMA_GetEvent=New LAMA_GetEvent
					LAMA\ID%=LAMA_TransferFailed%
					LAMA\PlayerID%=LAMA_Transfer\ID
					;datei-schliessen
					CloseFile(LAMA_Transfer\File)
					Delete LAMA_Transfer.LAMA_Transfer;datei-schliessen-und-bertragung-beenden
				EndIf
			EndIf
		Next
		;[End Block]
		;[Block] SecureSend
;		;Sichere-Send-Funktionen  ---> IN ARBEIT!!!
;		Local LAMA_SecurePlayerID%
;		Local LAMA_SecureMsgID%
;		Local LAMA_Secure.LAMA_SecureSend,LAMA_Secure2.LAMA_SecureSend
;		For LAMA_Secure.LAMA_SecureSend=Each LAMA_SecureSend
;			
;			;LAMA_SecurePlayerID%
;			;LAMA_SecureMsgID%=
;			If LAMA_PlayerOnline(LAMA_Secure\ID-1) Then
;				If LAMA_Secure\SendAccess%=True Then
;					WriteByte(LAMA_ServerStream%,200)
;					
;					WriteInt(LAMA_ServerStream%,LAMA_MasterID)
;					WriteInt(LAMA_ServerStream%,LAMA_Secure\ID)
;					
;					WriteInt(LAMA_ServerStream%,LAMA_Secure\MsgID)
;					
;					LAMA_VarType=LAMA_Identify(LAMA_Secure\Value$)
;					WriteByte(LAMA_ServerStream%,LAMA_VarType)
;					Select LAMA_VarType
;						Case 1
;							WriteByte(LAMA_ServerStream%,Int(LAMA_Secure\Value$))
;						Case 2
;							WriteShort(LAMA_ServerStream%,Int(LAMA_Secure\Value$))
;						Case 3
;							WriteInt(LAMA_ServerStream%,Int(LAMA_Secure\Value$))
;						Case 4
;							WriteFloat(LAMA_ServerStream%,Float(LAMA_Secure\Value$))
;						Case 5
;							WriteString(LAMA_ServerStream%,LAMA_Secure\Value$)
;					End Select
;					LAMA_Secure2.LAMA_SecureSend=After LAMA_Secure.LAMA_SecureSend
;					;If LAMA_Secure2.LAMA_SecureSend
;					
;					Select LAMA_Mode
;						Case LAMA_Host
;							SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP(LAMA_Secure\ID-1),LAMA_PlayerPort(LAMA_Secure\ID-1))
;						Case LAMA_Client
;							SendUDPMsg(LAMA_ServerStream%,LAMA_ServerIP,LAMA_ServerPort)
;					End Select
;					LAMA_Secure\SendAccess%=False
;				Else
;				EndIf
;			Else
;				Delete LAMA_Secure.LAMA_SecureSend
;			EndIf
;		Next
		;[End Block]
		
		;Ping
		If LAMA_Internet=1 And LAMA_Mode=LAMA_Host Then
			If LAMA_InternetMS<MilliSecs() Then
				;CloseTCPStream(LAMA_MasterServerStream)
				;LAMA_MasterServerStream=0
				
				;LAMA_MasterServerStream=OpenTCPStream(LAMA_MasterServerDetail,LAMA_MasterServerPort)
				;If LAMA_MasterServerStream<>0 Then
				
;				Command$="Servername="+ServerName$
;					WriteLine LAMA_MasterServerStream,"POST /Lama/UpdateServer.php HTTP/1.1"
;					WriteLine LAMA_MasterServerStream,"Host: "+LAMA_MasterServerDetail$
;					WriteLine LAMA_MasterServerStream,"User-Agent: LamaNet"
;					WriteLine LAMA_MasterServerStream,"Content-Type: application/x-www-form-urlencoded" 
;					WriteLine LAMA_MasterServerStream,"Content-Length: "+Len(Command$)
;					WriteLine LAMA_MasterServerStream,""
;					WriteLine LAMA_MasterServerStream,Command$
				
				
				WriteLine LAMA_MasterServerStream,"GET /Lama/UpdateServer.php HTTP/1.1"
				WriteLine LAMA_MasterServerStream,"Host: "+LAMA_MasterServerDetail$
				WriteLine LAMA_MasterServerStream,"User-Agent: LamaNet"
				
				WriteLine LAMA_MasterServerStream,"Keep-Alive: 115"
				WriteLine LAMA_MasterServerStream,"Connection: keep-alive"
				WriteLine LAMA_MasterServerStream,"Cache-Control: no-cache"
				WriteLine LAMA_MasterServerStream,""
				
				LAMA_InternetMS=MilliSecs()+LAMA_InternetPingTime
				;EndIf
			EndIf
		EndIf
		;If Not Eof(LAMA_MasterServerStream) Then WriteLine XFile,ReadLine(LAMA_MasterServerStream)
		
		
		;Timeout-funktionen
		If LAMA_Mode=LAMA_Host Then
			;bei-ping-timeout-spieler-kicken
			For LAMA_ID=1 To LAMA_ServerMaxPlayers
				If LAMA_PlayerOnline(LAMA_ID-1)=1 And LAMA_PlayerPing(LAMA_ID-1)>LAMA_TimeOut And LAMA_ID<>LAMA_MasterID Then
					LAMA_KickPlayer(LAMA_ID)
				EndIf
			Next
			;bann-liste-ueberpruefen-und-ggf-bann-freigeben.
			For LAMA_Ban.LAMA_BanList=Each LAMA_BanList
				If LAMA_Ban\MS>0 And MilliSecs()>LAMA_Ban\MS Then Delete LAMA_Ban.LAMA_BanList
			Next
		EndIf
		;nachrichten-empfangen
		While RecvUDPMsg(LAMA_ServerStream%)
			;While Not Eof(LAMA_ServerStream%)
			LAMA_Tag=ReadByte(LAMA_ServerStream%)
			Select LAMA_Mode%
				Case LAMA_Host%;HOST
					Select LAMA_Tag
						Case 1;server-information-request
							;Server-informationen-in-stream-schreiben
							Banned%=0
							For LAMA_Ban.LAMA_BanList=Each LAMA_BanList
								If LAMA_Ban\IP%=UDPMsgIP(LAMA_ServerStream%) Then Banned%=1:Exit
							Next
							If Banned%=0 Then
								Select FileType("LAMA_BanList.dat")
									Case 1
										BanList=OpenFile("LAMA_BanList.dat")
										While Not Eof(BanList)
											If ReadString(BanList)=DottedIP(UDPMsgIP(LAMA_ServerStream%)) Then Banned%=1:Exit
										Wend
										CloseFile BanList
								End Select
							EndIf
							WriteByte LAMA_DefaultStream%,1
							WriteInt LAMA_DefaultStream%,LAMA_ServerCode%
							WriteByte LAMA_DefaultStream%,Banned%
							WriteString LAMA_DefaultStream%,LAMA_ServerName$
							WriteInt LAMA_DefaultStream%,LAMA_ServerPlayers%
							WriteInt LAMA_DefaultStream%,LAMA_ServerMaxPlayers%
							WriteByte LAMA_DefaultStream%,LAMA_ServerLocked%
							If LAMA_ServerPassCode$<>"" Then WriteByte LAMA_DefaultStream%,1 Else WriteByte LAMA_DefaultStream%,0
							WriteString LAMA_DefaultStream%,LAMA_PlayerName$(LAMA_MasterID-1)
							For i=0 To 9
								LAMA_VarType=LAMA_Identify(LAMA_ServerInfo$(i))
								WriteByte(LAMA_DefaultStream%,LAMA_VarType)
								Select LAMA_VarType
									Case 1
										WriteByte(LAMA_DefaultStream%,Int(LAMA_ServerInfo$(i)))
									Case 2
										WriteShort(LAMA_DefaultStream%,Int(LAMA_ServerInfo$(i)))
									Case 3
										WriteInt(LAMA_DefaultStream%,Int(LAMA_ServerInfo$(i)))
									Case 4
										WriteFloat(LAMA_DefaultStream%,Float(LAMA_ServerInfo$(i)))
									Case 5
										WriteString(LAMA_DefaultStream%,LAMA_ServerInfo$(i))
									Case 6
										WriteByte(LAMA_DefaultStream%,Abs(Int(LAMA_ServerInfo$(i))))
									Case 7
										WriteShort(LAMA_DefaultStream%,Abs(Int(LAMA_ServerInfo$(i))))
									Case 8
										WriteInt(LAMA_DefaultStream%,Abs(Int(LAMA_ServerInfo$(i))))
								End Select
							Next
							;Server-informationen-abschicken
							SendUDPMsg(LAMA_DefaultStream%,UDPMsgIP(LAMA_ServerStream%),UDPMsgPort(LAMA_ServerStream%))
							LAMA.LAMA_GetEvent=New LAMA_GetEvent
							LAMA\ID%=LAMA_CountRequest%
						Case 2;server-join-request
							Banned%=0
							For LAMA_Ban.LAMA_BanList=Each LAMA_BanList
								If LAMA_Ban\IP%=UDPMsgIP(LAMA_ServerStream%) Then Banned%=1:Exit
							Next
							If Banned%=0 Then
								Select FileType("LAMA_BanList.dat")
									Case 1
										BanList=OpenFile("LAMA_BanList.dat")
										While Not Eof(BanList)
											If ReadString(BanList)=DottedIP(UDPMsgIP(LAMA_ServerStream%)) Then Banned%=1:Exit
										Wend
										CloseFile BanList
								End Select
							EndIf
							
							;neues-event-erstellen
							LAMA.LAMA_GetEvent=New LAMA_GetEvent
							LAMA\ID%=LAMA_JoinRequest%
							
							LAMA_PassCode$=ReadString(LAMA_ServerStream%)
							LAMA_NewPlayerName$=ReadString(LAMA_ServerStream%)
							Local NameExists=False
							For LAMA_ID%=1 To ServerMaxPlayers
								If LAMA_PlayerName(LAMA_ID%-1)=LAMA_NewPlayerName$ Then NameExists%=True
							Next
							If LAMA_ServerPlayers%<LAMA_ServerMaxPlayers% And Banned%=0 And LAMA_Pass(LAMA_PassCode$,LAMA_ServerPassCode$)=True And LAMA_HostServerLocked%=0 And NameExists%=0 Then
								;spieler-MS%-erhoehen
								LAMA_ServerPlayers%=LAMA_ServerPlayers%+1
								;freie-ID-suchen
								For LAMA_ID%=1 To LAMA_ServerMaxPlayers%
									If LAMA_PlayerOnline%(LAMA_ID%-1)=0 Then LAMA_NewPlayerID%=LAMA_ID%:Exit
								Next
								LAMA_PlayerIP%(LAMA_NewPlayerID%-1)=UDPMsgIP(LAMA_ServerStream%)
								LAMA_PlayerPort%(LAMA_NewPlayerID%-1)=UDPMsgPort(LAMA_ServerStream%)
								LAMA_PlayerName$(LAMA_NewPlayerID%-1)=LAMA_NewPlayerName$
								;LAMA_PlayerStream%(LAMA_NewPlayerID%-1)=CreateUDPStream()
								LAMA_PlayerOnline%(LAMA_NewPlayerID%-1)=1
								
								;antwort-versenden
								WriteByte(LAMA_ServerStream%,2)
								;informationen-fuer-client-bestimmt
								WriteInt(LAMA_ServerStream%,LAMA_MasterID%)
								WriteInt(LAMA_ServerStream%,LAMA_NewPlayerID%)
								;an-neuen-spieler-alle-infos-der-spieler-die-bereits-online-senden
								For LAMA_ID%=1 To LAMA_ServerMaxPlayers%
									If LAMA_PlayerOnline%(LAMA_ID%-1)=1 And LAMA_ID%<>LAMA_NewPlayerID% Then
										WriteInt(LAMA_ServerStream%,LAMA_ID%)
										WriteString(LAMA_ServerStream%,LAMA_PlayerName$(LAMA_ID%-1))
									EndIf
								Next
								SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP%(LAMA_NewPlayerID%-1),LAMA_PlayerPort%(LAMA_NewPlayerID%-1))
								;neues-event-erstellen
								LAMA.LAMA_GetEvent=New LAMA_GetEvent
								LAMA\ID%=LAMA_NewPlayer%
								LAMA\PlayerID%=LAMA_NewPlayerID%
								;infos-zum-neuen-spieler-an-alle-anderen-schicken
								For LAMA_ID%=1 To LAMA_ServerMaxPlayers%
									If LAMA_PlayerOnline%(LAMA_ID%-1)=1 And LAMA_ID%<>LAMA_NewPlayerID% And LAMA_ID%<>LAMA_MasterID Then
										WriteByte(LAMA_ServerStream%,144)
										WriteInt(LAMA_ServerStream%,LAMA_NewPlayerID%)
										WriteString(LAMA_ServerStream%,LAMA_NewPlayerName$)
										SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP%(LAMA_ID%-1),LAMA_PlayerPort%(LAMA_ID%-1))
									EndIf
								Next
							Else
								;neues-event-erstellen
								LAMA.LAMA_GetEvent=New LAMA_GetEvent
								LAMA\ID%=LAMA_JoinDenied%
								;spieler-verweigern
								WriteByte(LAMA_DefaultStream%,1)
								WriteByte(LAMA_DefaultStream%,Banned%)
								WriteByte(LAMA_DefaultStream%,NameExists%)
								WriteByte(LAMA_DefaultStream%,LAMA_ServerLocked())
								WriteByte(LAMA_DefaultStream%,LAMA_Pass(LAMA_PassCode$,LAMA_ServerPassCode$))
								If LAMA_ServerPlayers%=LAMA_ServerMaxPlayers% Then
									WriteByte(LAMA_DefaultStream%,1)
								Else
									WriteByte(LAMA_DefaultStream%,0)
								EndIf
								SendUDPMsg(LAMA_DefaultStream%,UDPMsgIP(LAMA_ServerStream%),UDPMsgPort(LAMA_ServerStream%))
								
								LAMA.LAMA_GetEvent=New LAMA_GetEvent
								LAMA\ID%=LAMA_PlayerBlocked%
							EndIf
						Case 3;spieler-verlaesst-das-spiel
							PlayerID%=ReadInt(LAMA_ServerStream%)
							;spieler-loeschen-udp-stream-schliessen-etc
							LAMA_PlayerOnline%(PlayerID%-1)=0
							LAMA_PlayerStream%(PlayerID%-1)=0
							LAMA_PlayerPingOK%(PlayerID%-1)=0
							LAMA_PlayerPing%(PlayerID%-1)=0
							LAMA_PlayerMS%(PlayerID%-1)=0
							LAMA_ServerPlayers%=LAMA_ServerPlayers%-1
							;infos-zum-spieler-kick-an-alle-anderen-schicken
							For LAMA_ID%=1 To LAMA_ServerMaxPlayers%
								If LAMA_PlayerOnline%(LAMA_ID%-1)=1 And LAMA_ID%<>LAMA_MasterID Then
									WriteByte(LAMA_ServerStream%,10);spieler-verlaesst-spiel
									WriteInt(LAMA_ServerStream%,PlayerID%)
									SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP%(LAMA_ID%-1),LAMA_PlayerPort%(LAMA_ID%-1))
								EndIf
							Next
							;neues-event-erstellen
							LAMA.LAMA_GetEvent=New LAMA_GetEvent
							LAMA\ID%=LAMA_PlayerLeft%
							LAMA\PlayerID%=PlayerID%
						Case 254;ping-antwort
							LAMA_ID%=ReadInt(LAMA_ServerStream%)
							LAMA_PlayerPingOK%(LAMA_ID%-1)=0
							LAMA_PlayerPing%(LAMA_ID%-1)=MilliSecs()-LAMA_PlayerMS%(LAMA_ID%-1)
					End Select
				Case LAMA_Client%;CLIENT
					Select LAMA_Tag
						Case 6;client-wurde-selbst-gekicked
							LAMA_MasterMessage$=""
							LAMA_PlayerMessage$(0)=""
							LAMA_Connection%=0
							For LAMA_ID%=0 To LAMA_ServerMaxPlayers%-1
								LAMA_PlayerOnline%(LAMA_ID%)=0
							Next
							;neues-event-erstellen
							LAMA.LAMA_GetEvent=New LAMA_GetEvent
							LAMA\ID%=LAMA_Kicked%
							LAMA\PlayerID%=LAMA_MasterID
							;upd-streams-schliessen
							If LAMA_ServerStream%>0 Then CloseUDPStream LAMA_ServerStream%:LAMA_ServerStream%=0
							Return 0
						Case 7;kick-eines-anderen-spielers
							LAMA_ID%=ReadInt(LAMA_ServerStream%)
							LAMA_PlayerOnline%(LAMA_ID%-1)=0
							;neues-event-erstellen
							LAMA.LAMA_GetEvent=New LAMA_GetEvent
							LAMA\ID%=LAMA_PlayerKicked%
							LAMA\PlayerID%=LAMA_ID%
							;neues-event-erstellen
							LAMA.LAMA_GetEvent=New LAMA_GetEvent
							LAMA\ID%=LAMA_PlayerLeft%
							LAMA\PlayerID%=LAMA_ID%
						Case 8;client-wurde-selbst-gebannt
							;neues-event-erstellen
							LAMA.LAMA_GetEvent=New LAMA_GetEvent
							LAMA\ID%=LAMA_Banned%
							LAMA\PlayerID%=LAMA_MasterID
							LAMA\Info$=ReadString(LAMA_ServerStream%)
						Case 9;bannen-eines-anderen-spielers
							LAMA_ID%=ReadInt(LAMA_ServerStream%)
							;neues-event-erstellen
							LAMA.LAMA_GetEvent=New LAMA_GetEvent
							LAMA\ID%=LAMA_PlayerBanned%
							LAMA\PlayerID%=LAMA_ID%
							LAMA\Info=ReadInt(LAMA_ServerStream%)
						Case 10;spieler-verlaesst-spiel
							LAMA_ID%=ReadInt(LAMA_ServerStream%)
							LAMA_PlayerOnline%(LAMA_ID%-1)=0
							;neues-event-erstellen
							LAMA.LAMA_GetEvent=New LAMA_GetEvent
							LAMA\ID%=LAMA_PlayerLeft%
							LAMA\PlayerID%=LAMA_ID%
						Case 11;server-schliesst
							;variablen-zuruecksetzen
							Dim LAMA_PlayerMSAnswer%(0)
							Dim LAMA_PlayerMessage$(0)
							Dim LAMA_PlayerPingOK%(0)
							Dim LAMA_PlayerOnline%(0)
							Dim LAMA_PlayerName$(0)
							Dim LAMA_PlayerPing%(0)
							Dim LAMA_PlayerPort%(0)
							Dim LAMA_PlayerIP%(0)
							Dim LAMA_Player%(0)
							Dim LAMA_PlayerMS%(0)
							;udp-streams-schliessen
							If LAMA_ServerStream%>0 Then CloseUDPStream(LAMA_ServerStream%):LAMA_ServerStream%=0
							LAMA_Connection%=False
							;neues-event-erstellen
							LAMA.LAMA_GetEvent=New LAMA_GetEvent
							LAMA\ID%=LAMA_ServerLeft%
							Return 0
						Case 80;Server-aendert-namen
							;neues-event-erstellen
							LAMA.LAMA_GetEvent=New LAMA_GetEvent
							LAMA\ID%=LAMA_ServerRenamed%
							LAMA\Info$=LAMA_ServerName$
							LAMA_ServerName$=ReadString(LAMA_ServerStream%)
						Case 81;Server-aendert-Informationen
							;neues-event-erstellen
							LAMA.LAMA_GetEvent=New LAMA_GetEvent
							LAMA\ID%=LAMA_ServerChangedInformation%
							LAMA\Info$=ReadByte(LAMA_ServerStream%)
							LAMA_ServerInfo$(LAMA\Info$)=ReadString(LAMA_ServerStream%)
						Case 144;player-information
							LAMA_ID%=ReadInt(LAMA_ServerStream%)
							LAMA_NewPlayerName$=ReadString(LAMA_ServerStream%)
							LAMA_PlayerName$(LAMA_ID%-1)=LAMA_NewPlayerName$
							LAMA_PlayerOnline%(LAMA_ID%-1)=1
							;spieler-anzahl-erhoehen
							LAMA_ServerPlayers%=LAMA_ServerPlayers%+1
							;neues-event-erstellen
							LAMA.LAMA_GetEvent=New LAMA_GetEvent
							LAMA\ID%=LAMA_NewPlayer
							LAMA\PlayerID%=LAMA_ID%
						Case 242;banktransfer
							LAMA_Gadget.LAMA_Gadget=New LAMA_Gadget
							LAMA_Gadget\BankID=ReadInt(LAMA_ServerStream%)
							LAMA_Gadget\Bytes=ReadInt(LAMA_ServerStream%)
							LAMA_Gadget\Bank=CreateBank(LAMA_Gadget\Bytes)
							For i=1 To LAMA_Gadget\Bytes
								PokeByte(LAMA_Gadget\Bank,i-1,ReadByte(LAMA_ServerStream%))
							Next
						Case 244;ping-info
							LAMA_ID%=ReadInt(LAMA_ServerStream%)
							LAMA_PlayerPing%(LAMA_ID%-1)=ReadInt(LAMA_ServerStream%)
							If LAMA_ID%=LAMA_ServerID% Then
								;millisekunden-zaehler-zuruecksetzen
								LAMA_PingMS%=MilliSecs()+LAMA_PingIntervall%
								LAMA_PlayerPing%(LAMA_MasterID-1)=LAMA_PlayerPing%(LAMA_ID%-1)
							EndIf
						Case 254;ping-request
							;antwort absenden
							WriteByte(LAMA_ServerStream%,254)
							WriteInt(LAMA_ServerStream%,LAMA_MasterID)
							SendUDPMsg(LAMA_ServerStream%,LAMA_ServerIP%,LAMA_ServerPort%)
					End Select
			End Select
			;MODUS-UNABHAENGIG
			Select LAMA_Tag
				Case 12;spieler-aendert-namen
					LAMA_ID2%=ReadInt(LAMA_ServerStream%)
					Local LAMA_OldName$=LAMA_PlayerName$(LAMA_ID2%-1)
					LAMA_PlayerName$(LAMA_ID2%-1)=ReadString(LAMA_ServerStream%)
					;neues-event-erstellen
					LAMA.LAMA_GetEvent=New LAMA_GetEvent
					LAMA\ID%=LAMA_PlayerRenamed%
					LAMA\PlayerID%=LAMA_ID2%
					LAMA\Info$=LAMA_OldName$
					
					If LAMA_Mode=LAMA_Host Then
						For LAMA_ID%=1 To LAMA_ServerMaxPlayers%
							If LAMA_PlayerOnline%(LAMA_ID%-1)=1 And LAMA_ID%<>LAMA_MasterID And LAMA_ID%<>LAMA_ID2% Then
								WriteByte(LAMA_ServerStream%,12)
								WriteInt(LAMA_ServerStream%,LAMA_ID2%)
								WriteString(LAMA_ServerStream%,LAMA_PlayerName$(LAMA_ID2%-1))
								SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP%(LAMA_ID%-1),LAMA_PlayerPort%(LAMA_ID%-1))
							EndIf
						Next
					EndIf
					;[Block] Normale Nachrichten ampfangen/weiterleiten
				Case 128;NormalSend-Funktion
					LAMA_ID%=ReadShort(LAMA_ServerStream%)
					PlayerID%=ReadShort(LAMA_ServerStream%)
					MsgID%=ReadShort(LAMA_ServerStream%)
					Tail%=ReadByte(LAMA_ServerStream%)
					If LAMA_Mode=LAMA_Host Then
						If PlayerID=0 Then
							Repeat
								LAMA_VarType=ReadByte(LAMA_ServerStream%)
								If LAMA_VarType<9 Then
									LAMA_MultiSend.LAMA_MultiSend=New LAMA_MultiSend
									LAMA_MultiSend\FromID=LAMA_ID%
									LAMA_MultiSend\ID=0
									LAMA_MultiSend\MsgID=MsgID%
									LAMA_MultiSend\Tail=Tail%
									Tail%=0
								EndIf
								
								Select LAMA_VarType
									Case 1
										LAMA_MultiSend\Value=ReadByte(LAMA_ServerStream%)
									Case 2
										LAMA_MultiSend\Value=ReadShort(LAMA_ServerStream%)
									Case 3
										LAMA_MultiSend\Value=ReadInt(LAMA_ServerStream%)
									Case 4
										LAMA_MultiSend\Value=ReadFloat(LAMA_ServerStream%)
									Case 5
										LAMA_MultiSend\Value=ReadString(LAMA_ServerStream%)
									Case 6
										LAMA_MultiSend\Value=-ReadByte(LAMA_ServerStream%)
									Case 7
										LAMA_MultiSend\Value=-ReadShort(LAMA_ServerStream%)
									Case 8
										LAMA_MultiSend\Value=-ReadInt(LAMA_ServerStream%)
									Default
										If LAMA_MultiSend\Tail<2 Then LAMA_MultiSend\Tail=LAMA_MultiSend\Tail+2
										Exit
								End Select
							Forever
						ElseIf LAMA_MasterID<>PlayerID% Then
							If LAMA_PlayerOnline(PlayerID-1) Then
								WriteByte(LAMA_ServerStream,128)
								WriteShort(LAMA_ServerStream%,LAMA_ID%)
								WriteShort(LAMA_ServerStream%,PlayerID%)
								WriteShort(LAMA_ServerStream%,MsgID%)
								WriteByte(LAMA_ServerStream%,Tail%)
								
								LAMA_TempSecure=ReadByte(LAMA_ServerStream%)
								WriteByte(LAMA_ServerStream%,LAMA_TempSecure)
								If LAMA_TempSecure=1 Then
									WriteShort(LAMA_ServerStream%,ReadShort(LAMA_ServerStream%))
								EndIf
								Repeat
									LAMA_VarType=ReadByte(LAMA_ServerStream%)
									If LAMA_VarType<9 Then WriteByte(LAMA_ServerStream%,LAMA_VarType)
									Select LAMA_VarType
										Case 1
											WriteByte(LAMA_ServerStream%,ReadByte(LAMA_ServerStream%))
										Case 2
											WriteShort(LAMA_ServerStream%,ReadShort(LAMA_ServerStream%))
										Case 3
											WriteInt(LAMA_ServerStream%,ReadInt(LAMA_ServerStream%))
										Case 4
											WriteFloat(LAMA_ServerStream%,ReadFloat(LAMA_ServerStream%))
										Case 5
											WriteString(LAMA_ServerStream%,ReadString(LAMA_ServerStream%))
										Case 6
											WriteByte(LAMA_ServerStream%,ReadByte(LAMA_ServerStream%))
										Case 7
											WriteShort(LAMA_ServerStream%,ReadShort(LAMA_ServerStream%))
										Case 8
											WriteInt(LAMA_ServerStream%,ReadInt(LAMA_ServerStream%))
										Default
											Exit
									End Select
								Forever
								WriteByte(LAMA_ServerStream,255)
								SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP(PlayerID%-1),LAMA_PlayerPort(PlayerID%-1))
							Else
								LAMA_TempSecure=ReadByte(LAMA_ServerStream%)
								If LAMA_TempSecure=1 Then ReadShort(LAMA_ServerStream%)
								Repeat
									LAMA_VarType=ReadByte(LAMA_ServerStream%)
									Select LAMA_VarType
										Case 1
											ReadByte(LAMA_ServerStream%)
										Case 2
											ReadShort(LAMA_ServerStream%)
										Case 3
											ReadInt(LAMA_ServerStream%)
										Case 4
											ReadFloat(LAMA_ServerStream%)
										Case 5
											ReadString(LAMA_ServerStream%)
										Case 6
											ReadByte(LAMA_ServerStream%)
										Case 7
											ReadShort(LAMA_ServerStream%)
										Case 8
											ReadInt(LAMA_ServerStream%)
										Default
											Exit
									End Select
								Forever
							EndIf
						EndIf
					EndIf
					If PlayerID%=LAMA_MasterID Then
						LAMA_TempSecure=ReadByte(LAMA_ServerStream%)
						If LAMA_TempSecure=1 Then
							SecureID=ReadShort(LAMA_ServerStream%)
							
							WriteByte(LAMA_ServerStream%,129)
							WriteShort(LAMA_ServerStream%,LAMA_MasterID)
							WriteShort(LAMA_ServerStream%,LAMA_ID%)
							WriteShort(LAMA_ServerStream%,SecureID%)
							Select LAMA_Mode
								Case LAMA_Host
									SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP(LAMA_ID%-1),LAMA_PlayerPort(LAMA_ID%-1))
								Case LAMA_Client
									SendUDPMsg(LAMA_ServerStream%,LAMA_ServerIP,LAMA_ServerPort)
							End Select
						EndIf
						Repeat
							LAMA_VarType=ReadByte(LAMA_ServerStream%)
							If LAMA_VarType<9 Then
								LAMA_RecvMsg.LAMA_RecvMsg=New LAMA_RecvMsg
								LAMA_RecvMsg\FromID=LAMA_ID
								LAMA_RecvMsg\MsgID=MsgID	
							EndIf
							Select LAMA_VarType
								Case 1
									LAMA_RecvMsg\Value=ReadByte(LAMA_ServerStream%)
								Case 2
									LAMA_RecvMsg\Value=ReadShort(LAMA_ServerStream%)
								Case 3
									LAMA_RecvMsg\Value=ReadInt(LAMA_ServerStream%)
								Case 4
									LAMA_RecvMsg\Value=ReadFloat(LAMA_ServerStream%)
								Case 5
									LAMA_RecvMsg\Value=ReadString(LAMA_ServerStream%)
								Case 6
									LAMA_RecvMsg\Value=-ReadByte(LAMA_ServerStream%)
								Case 7
									LAMA_RecvMsg\Value=-ReadShort(LAMA_ServerStream%)
								Case 8
									LAMA_RecvMsg\Value=-ReadInt(LAMA_ServerStream%)
								Default
									Exit
							End Select
						Forever
					EndIf
				Case 129;Secure-angekommen
					LAMA_ID=ReadShort(LAMA_ServerStream%)
					PlayerID=ReadShort(LAMA_ServerStream%)
					SecureID=ReadShort(LAMA_ServerStream%)
					Select LAMA_Mode
						Case LAMA_Host
							If PlayerID=LAMA_MasterID Then
								For LAMA_NormalSend.LAMA_NormalSend=Each LAMA_NormalSend
									If LAMA_NormalSend\Secure=1 And LAMA_ID=LAMA_NormalSend\ID And SecureID=LAMA_NormalSend\SecureID Then
										Delete LAMA_NormalSend.LAMA_NormalSend
									EndIf
								Next
							Else
								WriteByte(LAMA_ServerStream%,129)
								WriteShort(LAMA_ServerStream%,LAMA_ID)
								WriteShort(LAMA_ServerStream%,PlayerID)
								WriteShort(LAMA_ServerStream%,SecureID)
								SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP(PlayerID-1),LAMA_PlayerPort(PlayerID-1))
							EndIf
						Case LAMA_Client
							For LAMA_NormalSend.LAMA_NormalSend=Each LAMA_NormalSend
								If LAMA_NormalSend\Secure=1 And LAMA_ID=LAMA_NormalSend\ID And SecureID=LAMA_NormalSend\SecureID Then
									Delete LAMA_NormalSend.LAMA_NormalSend
								EndIf
							Next
					End Select
					;[End Block]
					;[Block] Dateiempfangen/weiterleiten
				Case 219;filetransfer-abbrechen
					LAMA_ID%=ReadInt(LAMA_ServerStream%)
					PlayerID%=ReadInt(LAMA_ServerStream%)
					If LAMA_Mode=1 And LAMA_MasterID<>PlayerID% Then
						WriteByte(LAMA_ServerStream,219)
						WriteInt(LAMA_ServerStream%,LAMA_ID%)
						WriteInt(LAMA_ServerStream%,PlayerID%)
						WriteInt(LAMA_ServerStream%,ReadInt(LAMA_ServerStream%))
						SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP(PlayerID%-1),LAMA_PlayerPort(PlayerID%-1))
					Else
						LAMA_FileRead=ReadInt(LAMA_ServerStream%)
						For LAMA_Transfer.LAMA_Transfer=Each LAMA_Transfer
							If LAMA_FileRead=LAMA_Transfer\FileID Then
								CloseFile LAMA_Transfer\File
								
								;neues-event-erstellen
								LAMA.LAMA_GetEvent=New LAMA_GetEvent
								LAMA\ID%=LAMA_PlayerCanceledTransfer%
								LAMA\PlayerID%=LAMA_ID%
								LAMA\Info=LAMA_Transfer\Name+"."+LAMA_Transfer\Ending
								
								Delete LAMA_Transfer.LAMA_Transfer
								Exit
							EndIf
						Next
					EndIf
				Case 229;filetransfer
					LAMA_ID%=ReadInt(LAMA_ServerStream%)
					PlayerID%=ReadInt(LAMA_ServerStream%)
					If LAMA_Mode=1 And LAMA_MasterID<>PlayerID% Then
						WriteByte(LAMA_ServerStream,229)
						WriteInt(LAMA_ServerStream%,LAMA_ID%)
						WriteInt(LAMA_ServerStream%,PlayerID%)
						WriteInt(LAMA_ServerStream%,ReadInt(LAMA_ServerStream%))
						SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP(PlayerID%-1),LAMA_PlayerPort(PlayerID%-1))
					Else
						LAMA_FileRead=ReadInt(LAMA_ServerStream%)
						For LAMA_Transfer.LAMA_Transfer=Each LAMA_Transfer
							If LAMA_FileRead=LAMA_Transfer\FileID And LAMA_Transfer\SendOrRecv=1 Then
								LAMA_Transfer\SendAccess=True
								LAMA_Transfer\MS%=MilliSecs()+LAMA_TransferTimeOut%
								SeekFile(LAMA_Transfer\File,FilePos(LAMA_Transfer\File)-LAMA_PackageSize%)
								Exit
							EndIf
						Next
					EndIf
				Case 230;filetransfer
					LAMA_ID%=ReadInt(LAMA_ServerStream%)
					PlayerID%=ReadInt(LAMA_ServerStream%)
					If LAMA_Mode=1 And LAMA_MasterID<>PlayerID% Then
						WriteByte(LAMA_ServerStream,230)
						WriteInt(LAMA_ServerStream%,LAMA_ID%)
						WriteInt(LAMA_ServerStream%,PlayerID%)
						WriteInt(LAMA_ServerStream%,ReadInt(LAMA_ServerStream%))
						SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP(PlayerID%-1),LAMA_PlayerPort(PlayerID%-1))
					Else
						LAMA_FileRead=ReadInt(LAMA_ServerStream%)
						For LAMA_Transfer.LAMA_Transfer=Each LAMA_Transfer
							If LAMA_FileRead=LAMA_Transfer\FileID And LAMA_Transfer\SendOrRecv=1 Then
								LAMA_Transfer\SendAccess=True
								LAMA_Transfer\MS%=MilliSecs()+LAMA_TransferTimeOut%
								LAMA_Transfer\PackageIndex=LAMA_Transfer\PackageIndex+1
								Exit
							EndIf
						Next
					EndIf
				Case 220;filetransfer
					LAMA_ID%=ReadInt(LAMA_ServerStream%)
					PlayerID%=ReadInt(LAMA_ServerStream%)
					If LAMA_Mode=1 And LAMA_MasterID<>PlayerID% Then
						LAMA_FileRead=ReadByte(LAMA_ServerStream%)
						Select LAMA_FileRead
							Case 1
								WriteByte(LAMA_ServerStream,220)
								WriteInt(LAMA_ServerStream%,LAMA_ID%)
								WriteInt(LAMA_ServerStream%,PlayerID%)
								
								WriteByte(LAMA_ServerStream%,1)
								WriteString(LAMA_ServerStream%,ReadString(LAMA_ServerStream%))
								WriteString(LAMA_ServerStream%,ReadString(LAMA_ServerStream%))
								WriteInt(LAMA_ServerStream%,ReadInt(LAMA_ServerStream%))
								WriteInt(LAMA_ServerStream%,ReadInt(LAMA_ServerStream%))
								WriteInt(LAMA_ServerStream%,ReadInt(LAMA_ServerStream%))
							Case 0
								WriteByte(LAMA_ServerStream,220)
								WriteInt(LAMA_ServerStream%,LAMA_ID%)
								WriteInt(LAMA_ServerStream%,PlayerID%)
								
								WriteByte(LAMA_ServerStream%,0)
								WriteInt(LAMA_ServerStream%,ReadInt(LAMA_ServerStream%))
								WriteInt(LAMA_ServerStream%,ReadInt(LAMA_ServerStream%))
								WriteByte(LAMA_ServerStream%,ReadByte(LAMA_ServerStream%));transferende
								LAMA_Avail=ReadShort(LAMA_ServerStream%)
								WriteShort(LAMA_ServerStream%,LAMA_Avail)
								For i=1 To LAMA_Avail
									WriteByte(LAMA_ServerStream%,ReadByte(LAMA_ServerStream%))
								Next
								WriteFloat(LAMA_ServerStream%,ReadFloat(LAMA_ServerStream%))
						End Select
						SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP(PlayerID%-1),LAMA_PlayerPort(PlayerID%-1))
					Else
						LAMA_FileEnd=0
						LAMA_FileRead=ReadByte(LAMA_ServerStream%)
						Select LAMA_FileRead
							Case 1
								LAMA_Transfer.LAMA_Transfer=New LAMA_Transfer
								LAMA_Transfer\ID=LAMA_ID%
								
								LAMA_Transfer\Path$=LAMA_Path$
								LAMA_Transfer\PackageIndex=1
								
								LAMA_Transfer\Name$=ReadString(LAMA_ServerStream%)
								LAMA_Transfer\Ending$=ReadString(LAMA_ServerStream%)
								LAMA_Transfer\FileID=ReadInt(LAMA_ServerStream%)
								LAMA_Transfer\GadgetID=ReadInt(LAMA_ServerStream%)
								LAMA_Transfer\Bytes=ReadInt(LAMA_ServerStream%)
								LAMA_Transfer\MS%=MilliSecs()+LAMA_TransferTimeOut%
								LAMA_File$=LAMA_Transfer\Path$+LAMA_Transfer\Name$
								If FileType(LAMA_File$+"."+LAMA_Transfer\Ending)=1 Then
									i=1
									Repeat
										i=i+1
										If FileType(LAMA_File$+"("+i+")."+LAMA_Transfer\Ending)=0 Then
											LAMA_Transfer\File=WriteFile(LAMA_File$+"("+i+")."+LAMA_Transfer\Ending$)
											Exit
										EndIf
									Forever
								Else
									LAMA_Transfer\File=WriteFile(LAMA_File$+"."+LAMA_Transfer\Ending)
								EndIf
								LAMA_Transfer\SendOrRecv=2
							Case 0
								LAMA_PackageIndex=ReadInt(LAMA_ServerStream%)
								LAMA_FileRead=ReadInt(LAMA_ServerStream%)
								FileFound=0
								For LAMA_Transfer.LAMA_Transfer=Each LAMA_Transfer
									If LAMA_FileRead=LAMA_Transfer\FileID And LAMA_Transfer\SendOrRecv=2 Then
										FileFound=1
										LAMA_FileEnd=ReadByte(LAMA_ServerStream%);transferende
										LAMA_Avail=ReadShort(LAMA_ServerStream%)
										LAMA_Transfer\MS%=MilliSecs()+LAMA_TransferTimeOut%
										If LAMA_Transfer\PackageIndex=LAMA_PackageIndex Then
											For i=1 To LAMA_Avail
												LAMA_Byte=ReadByte(LAMA_ServerStream%)
												WriteByte(LAMA_Transfer\File,LAMA_Byte);byte-filebyte
											Next
										Else
											For i=1 To LAMA_Avail
												ReadByte(LAMA_ServerStream%)
											Next
										EndIf
										LAMA_Transfer\Progress=ReadFloat(LAMA_ServerStream%)
										If LAMA_FileEnd=0 And LAMA_Transfer\PackageIndex=LAMA_PackageIndex Then
											LAMA_Transfer\PackageIndex=LAMA_PackageIndex+1
											WriteByte(LAMA_ServerStream%,230)
											WriteInt(LAMA_ServerStream%,LAMA_MasterID)
											WriteInt(LAMA_ServerStream%,LAMA_Transfer\ID)
											WriteInt(LAMA_ServerStream%,LAMA_Transfer\FileID)
											Select LAMA_Mode
												Case LAMA_Host
													SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP(LAMA_Transfer\ID-1),LAMA_PlayerPort(LAMA_Transfer\ID-1))
												Case LAMA_Client
													SendUDPMsg(LAMA_ServerStream%,LAMA_ServerIP,LAMA_ServerPort)
											End Select
										EndIf
										If LAMA_FileEnd=1 Then
											LAMA_Gadget.LAMA_Gadget=New LAMA_Gadget
											LAMA_Gadget\GadgetID=LAMA_Transfer\GadgetID
											LAMA_Gadget\Name=LAMA_Transfer\Name
											LAMA_Gadget\Ending=LAMA_Transfer\Ending
											LAMA_Gadget\Path=LAMA_Transfer\Path
											LAMA_Gadget\Bytes=LAMA_Transfer\Bytes
											;neues-event-erstellen
											LAMA.LAMA_GetEvent=New LAMA_GetEvent
											LAMA\ID%=LAMA_ReceivedFile%
											LAMA\PlayerID%=LAMA_Transfer\ID
											;datei-schliessen
											CloseFile LAMA_Transfer\File
											Delete LAMA_Transfer.LAMA_Transfer
										EndIf
										Exit
									EndIf
								Next
								If FileFound=0 Then
									ReadByte(LAMA_ServerStream%)
									LAMA_Avail=ReadShort(LAMA_ServerStream%)
									For i=1 To LAMA_Avail
										ReadByte(LAMA_ServerStream%)
									Next
									ReadFloat(LAMA_ServerStream%)
								EndIf
						End Select
					EndIf
					;[End Block]
			End Select
		Wend
		;[Block] Normale Nachrichten
		;gespeicherte-nachrichten-absenden
		If Last LAMA_NormalSend<>Null Then
			LAMA_NormalSend.LAMA_NormalSend=Last LAMA_NormalSend
			If LAMA_NormalSend\Tail<2 Then LAMA_NormalSend\Tail=LAMA_NormalSend\Tail+2
		EndIf
		Local LAMA_SecureSend.LAMA_SecureSend
		If Last LAMA_SecureSend<>Null Then
			LAMA_SecureSend.LAMA_SecureSend=Last LAMA_SecureSend
			If LAMA_SecureSend\Tail<2 Then LAMA_SecureSend\Tail=LAMA_SecureSend\Tail+2
		EndIf
		For LAMA_ID%=1 To LAMA_ServerMaxPlayers
			If LAMA_ID<>LAMA_MasterID And LAMA_PlayerOnline(LAMA_ID-1)=1 Then
				For LAMA_SecureSend.LAMA_SecureSend=Each LAMA_SecureSend
					LAMA_NormalSend.LAMA_NormalSend=New LAMA_NormalSend
					LAMA_NormalSend\ID=LAMA_ID
					LAMA_NormalSend\MsgID=LAMA_SecureSend\MsgID
					LAMA_NormalSend\Value=LAMA_SecureSend\Value
					LAMA_NormalSend\Tail=LAMA_SecureSend\Tail
					If (LAMA_NormalSend\Tail Mod 2)=1 Then
						LAMA_SecureIndex%=(LAMA_SecureIndex%+1) Mod 65536
						LAMA_NormalSend\MS=MilliSecs()+LAMA_SecureTimeOut%
					EndIf
					LAMA_NormalSend\SecureID=LAMA_SecureIndex%
					LAMA_NormalSend\SendAccess=True
					LAMA_NormalSend\Secure=True
				Next
			EndIf
		Next
		For LAMA_NormalSend.LAMA_NormalSend=Each LAMA_NormalSend
			If LAMA_NormalSend\MS<MilliSecs() And LAMA_NormalSend\SendAccess=False And LAMA_NormalSend\Secure=1 And (LAMA_NormalSend\Tail Mod 2)=1 Then
				LAMA_NormalSend\MS=MilliSecs()+LAMA_SecureTimeOut%
				LAMA_NormalSend\SendAccess=True
				LAMA_NormalSend\Trys=LAMA_NormalSend\Trys+1
			EndIf
			If LAMA_NormalSend\ID>0 Then
				If LAMA_PlayerOnline(LAMA_NormalSend\ID-1)=0 Then Delete LAMA_NormalSend.LAMA_NormalSend
			EndIf
		Next
		;temporaer-secure-loeschen!
		For LAMA_SecureSend.LAMA_SecureSend=Each LAMA_SecureSend
			Delete LAMA_SecureSend.LAMA_SecureSend
		Next
		;senden
		Local LAMA_TempAccess=0
		Select LAMA_Mode
			Case LAMA_Host
				For LAMA_NormalSend.LAMA_NormalSend=Each LAMA_NormalSend;Multisends-bestimmen!
					If LAMA_NormalSend\ID=0 Then
						LAMA_MultiSend.LAMA_MultiSend=New LAMA_MultiSend
						LAMA_MultiSend\FromID=LAMA_MasterID
						LAMA_MultiSend\ID=0
						LAMA_MultiSend\MsgID=LAMA_NormalSend\MsgID
						LAMA_MultiSend\Value=LAMA_NormalSend\Value
						LAMA_MultiSend\Tail=LAMA_NormalSend\Tail
						Delete LAMA_NormalSend.LAMA_NormalSend
					EndIf
				Next
				For LAMA_NormalSend.LAMA_NormalSend=Each LAMA_NormalSend
					If LAMA_PlayerOnline(LAMA_NormalSend\ID-1) Then
						If LAMA_NormalSend\SendAccess=1 Then LAMA_TempAccess=1:LAMA_NormalSend\SendAccess=0
						If LAMA_NormalSend\Secure=0 Or LAMA_TempAccess=1 Then
							LAMA_VarType=LAMA_Identify(LAMA_NormalSend\Value$)
							If (LAMA_NormalSend\Tail Mod 2)=1 Then
								WriteByte(LAMA_ServerStream%,128);Start
								WriteShort(LAMA_ServerStream%,LAMA_MasterID)
								WriteShort(LAMA_ServerStream%,LAMA_NormalSend\ID)
								WriteShort(LAMA_ServerStream%,LAMA_NormalSend\MsgID)
								WriteByte(LAMA_ServerStream%,LAMA_NormalSend\Tail)
								
								;sicheres-senden
								WriteByte(LAMA_ServerStream%,LAMA_NormalSend\Secure)
								If LAMA_NormalSend\Secure=1 Then
									WriteShort(LAMA_ServerStream%,LAMA_NormalSend\SecureID)
								EndIf
							EndIf
							WriteByte(LAMA_ServerStream%,LAMA_VarType);VarID
							Select LAMA_VarType
								Case 1
									WriteByte(LAMA_ServerStream%,Int(LAMA_NormalSend\Value))
								Case 2
									WriteShort(LAMA_ServerStream%,Int(LAMA_NormalSend\Value))
								Case 3
									WriteInt(LAMA_ServerStream%,Int(LAMA_NormalSend\Value))
								Case 4
									WriteFloat(LAMA_ServerStream%,Float(LAMA_NormalSend\Value))
								Case 5
									WriteString(LAMA_ServerStream%,LAMA_NormalSend\Value)
								Case 6
									WriteByte(LAMA_ServerStream%,Abs(Int(LAMA_NormalSend\Value)))
								Case 7
									WriteShort(LAMA_ServerStream%,Abs(Int(LAMA_NormalSend\Value)))
								Case 8
									WriteInt(LAMA_ServerStream%,Abs(Int(LAMA_NormalSend\Value)))
							End Select
							If LAMA_NormalSend\Tail>1 Then
								WriteByte(LAMA_ServerStream%,255);Ende
								SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP%(LAMA_NormalSend\ID-1),LAMA_PlayerPort%(LAMA_NormalSend\ID-1))
								
								LAMA_TempAccess=0
							EndIf
						EndIf
					Else
						Delete LAMA_NormalSend.LAMA_NormalSend
					EndIf
					If LAMA_NormalSend\Secure=0 Then Delete LAMA_NormalSend.LAMA_NormalSend
				Next
				;[Block] Mulitsend
				For LAMA_ID%=1 To LAMA_ServerMaxPlayers
					If LAMA_PlayerOnline(LAMA_ID-1)=True And LAMA_ID%<>LAMA_MasterID Then
						For LAMA_MultiSend.LAMA_MultiSend=Each LAMA_MultiSend
							If LAMA_ID%<>LAMA_MultiSend\FromID Then
								LAMA_VarType=LAMA_Identify(LAMA_MultiSend\Value$)
								If LAMA_MultiSend\Tail=1 Or LAMA_MultiSend\Tail=3 Then
									WriteByte(LAMA_ServerStream%,128);Start
									WriteShort(LAMA_ServerStream%,LAMA_MultiSend\FromID)
									WriteShort(LAMA_ServerStream%,LAMA_ID%)
									WriteShort(LAMA_ServerStream%,LAMA_MultiSend\MsgID)
									WriteByte(LAMA_ServerStream%,LAMA_MultiSend\Tail)
									
									WriteByte(LAMA_ServerStream%,0)
								EndIf
								
								WriteByte(LAMA_ServerStream%,LAMA_VarType);VarID
								Select LAMA_VarType
									Case 1
										WriteByte(LAMA_ServerStream%,Int(LAMA_MultiSend\Value))
									Case 2
										WriteShort(LAMA_ServerStream%,Int(LAMA_MultiSend\Value))
									Case 3
										WriteInt(LAMA_ServerStream%,Int(LAMA_MultiSend\Value))
									Case 4
										WriteFloat(LAMA_ServerStream%,Float(LAMA_MultiSend\Value))
									Case 5
										WriteString(LAMA_ServerStream%,LAMA_MultiSend\Value$)
									Case 6
										WriteByte(LAMA_ServerStream%,Abs(Int(LAMA_MultiSend\Value)))
									Case 7
										WriteShort(LAMA_ServerStream%,Abs(Int(LAMA_MultiSend\Value)))
									Case 8
										WriteInt(LAMA_ServerStream%,Abs(Int(LAMA_MultiSend\Value)))
								End Select
								
								If LAMA_MultiSend\Tail=2 Or LAMA_MultiSend\Tail=3 Then
									WriteByte(LAMA_ServerStream%,255);Ende
									SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP%(LAMA_ID-1),LAMA_PlayerPort%(LAMA_ID-1))
								EndIf
							EndIf
						Next
					EndIf
				Next
				For LAMA_MultiSend.LAMA_MultiSend=Each LAMA_MultiSend
					If LAMA_MultiSend\FromID<>LAMA_MasterID Then
						LAMA_RecvMsg.LAMA_RecvMsg=New LAMA_RecvMsg
						LAMA_RecvMsg\FromID=LAMA_MultiSend\FromID
						LAMA_RecvMsg\MsgID=LAMA_MultiSend\MsgID
						LAMA_RecvMsg\Value=LAMA_MultiSend\Value
					EndIf
					Delete LAMA_MultiSend.LAMA_MultiSend
				Next
				;[End Block]
			Case LAMA_Client
				For LAMA_NormalSend.LAMA_NormalSend=Each LAMA_NormalSend
					If LAMA_NormalSend\SendAccess=1 Then LAMA_TempAccess=1:LAMA_NormalSend\SendAccess=0
					If LAMA_NormalSend\Secure=0 Or LAMA_TempAccess=1 Then
						LAMA_VarType=LAMA_Identify(LAMA_NormalSend\Value$)
						If (LAMA_NormalSend\Tail Mod 2)=1 Then
							WriteByte(LAMA_ServerStream%,128);Start
							WriteShort(LAMA_ServerStream%,LAMA_MasterID)
							WriteShort(LAMA_ServerStream%,LAMA_NormalSend\ID)
							WriteShort(LAMA_ServerStream%,LAMA_NormalSend\MsgID)
							WriteByte(LAMA_ServerStream%,LAMA_NormalSend\Tail)
							If LAMA_NormalSend\Secure=1 Then
								;sicheres-senden
								WriteByte(LAMA_ServerStream%,LAMA_NormalSend\Secure)
								If LAMA_NormalSend\Secure=1 Then
									WriteShort(LAMA_ServerStream%,LAMA_NormalSend\SecureID)
								EndIf
							EndIf
						EndIf
						WriteByte(LAMA_ServerStream%,LAMA_VarType);VarID
						Select LAMA_VarType
							Case 1
								WriteByte(LAMA_ServerStream%,Int(LAMA_NormalSend\Value))
							Case 2
								WriteShort(LAMA_ServerStream%,Int(LAMA_NormalSend\Value))
							Case 3
								WriteInt(LAMA_ServerStream%,Int(LAMA_NormalSend\Value))
							Case 4
								WriteFloat(LAMA_ServerStream%,Float(LAMA_NormalSend\Value))
							Case 5
								WriteString(LAMA_ServerStream%,LAMA_NormalSend\Value)
							Case 6
								WriteByte(LAMA_ServerStream%,Abs(Int(LAMA_NormalSend\Value)))
							Case 7
								WriteShort(LAMA_ServerStream%,Abs(Int(LAMA_NormalSend\Value)))
							Case 8
								WriteInt(LAMA_ServerStream%,Abs(Int(LAMA_NormalSend\Value)))
						End Select
						If LAMA_NormalSend\Tail>1 Then
							WriteByte(LAMA_ServerStream%,255);Ende
							SendUDPMsg(LAMA_ServerStream%,LAMA_ServerIP,LAMA_ServerPort)
							
							LAMA_TempAccess=0
						EndIf
					EndIf
					If LAMA_NormalSend\Secure=0 Then Delete LAMA_NormalSend.LAMA_NormalSend
				Next
		End Select
		Local LAMA_NormalSend2.LAMA_NormalSend
		For LAMA_NormalSend.LAMA_NormalSend=Each LAMA_NormalSend
			If LAMA_NormalSend\Trys=LAMA_SecureTrys+1 Then
				LAMA_TempAccess=LAMA_NormalSend\SecureID
				Delete LAMA_NormalSend.LAMA_NormalSend
				For LAMA_NormalSend2.LAMA_NormalSend=Each LAMA_NormalSend
					If LAMA_NormalSend2\SecureID=LAMA_TempAccess Then Delete LAMA_NormalSend2.LAMA_NormalSend
				Next
			EndIf
		Next
		LAMA_TempAccess=0
		;[End Block]
		;[Block] Ping
		;ping
		Select LAMA_Mode
			Case LAMA_Host;wenn-computer-host-ist
				For LAMA_ID%=1 To LAMA_ServerMaxPlayers%
					If LAMA_ID%<>LAMA_MasterID Then
						;ping berechnen
						;wenn-spieler-online-und-geantwortet-hat
						If LAMA_PlayerOnline%(LAMA_ID%-1)=1 Then
							;wenn-ping-zaehler-noch-nicht-aktiviert-wurde
							If LAMA_PlayerMS%(LAMA_ID%-1)=0 Then LAMA_PlayerMS%(LAMA_ID%-1)=MilliSecs()
							If (LAMA_PlayerPingOK%(LAMA_ID%-1)=1 And LAMA_PingMS%<MilliSecs()) Then
								LAMA_PlayerPing%(LAMA_ID%-1)=MilliSecs()-LAMA_PlayerMS%(LAMA_ID%-1)
							EndIf
						EndIf
						;ping-senden
						If LAMA_PlayerOnline%(LAMA_ID%-1)=1 Then
							If LAMA_PlayerPingOK%(LAMA_ID%-1)=0 And LAMA_PingMS%<MilliSecs() Then
								WriteByte(LAMA_ServerStream%,254)
								SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP%(LAMA_ID%-1),LAMA_PlayerPort%(LAMA_ID%-1))
								LAMA_PlayerMS%(LAMA_ID%-1)=MilliSecs()
								LAMA_PlayerPingOK%(LAMA_ID%-1)=1
								For LAMA_ID2%=1 To LAMA_ServerMaxPlayers%
									If LAMA_ID2%<>LAMA_MasterID Then
										WriteByte(LAMA_ServerStream%,244);ping-message
										If LAMA_ID2%<>LAMA_ID% Then WriteInt(LAMA_ServerStream%,LAMA_ID2%)
										If LAMA_ID2%=LAMA_ID% Then WriteInt(LAMA_ServerStream%,1)
										WriteInt(LAMA_ServerStream%,LAMA_PlayerPing%(LAMA_ID2%-1))
										SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP%(LAMA_ID%-1),LAMA_PlayerPort%(LAMA_ID%-1))
									EndIf
								Next
							EndIf
						EndIf
					EndIf
				Next
				;millisekunden-zaehler-zuruecksetzen
				If LAMA_PingMS%<MilliSecs() Then LAMA_PingMS%=MilliSecs()+LAMA_PingIntervall%
			Case LAMA_Client;wenn-computer-client-ist
				If LAMA_PingMS%<MilliSecs() Then
					For LAMA_ID%=1 To LAMA_ServerMaxPlayers%
						If LAMA_ID%<>LAMA_MasterID% Then LAMA_PlayerPing%(LAMA_ID%-1)=LAMA_PlayerPing%(LAMA_ServerID%-1)+LAMA_PingIntervall%
					Next
					LAMA_PingMS%=MilliSecs()+LAMA_PingIntervall%
				EndIf
				If LAMA_PlayerPing%(LAMA_ServerID%-1)>LAMA_TimeOut% Then
					;UDP-stream-schliessen
					If LAMA_ServerStream%>0 Then CloseUDPStream(LAMA_ServerStream%):LAMA_ServerStream%=0
					For LAMA_ID%=1 To LAMA_ServerMaxPlayers%
						LAMA_PlayerOnline%(LAMA_ID%-1)=0
					Next
					LAMA_Connection%=False
					LAMA_ServerMaxPlayers%=0
				EndIf
		End Select
		
		;[End Block]
	Else
		For LAMA_NormalSend.LAMA_NormalSend=Each LAMA_NormalSend
			Delete LAMA_NormalSend
		Next
		For LAMA_MultiSend.LAMA_MultiSend=Each LAMA_MultiSend
			Delete LAMA_MultiSend.LAMA_MultiSend
		Next
		For LAMA_RecvMsg.LAMA_RecvMsg=Each LAMA_RecvMsg
			Delete LAMA_RecvMsg.LAMA_RecvMsg
		Next
	EndIf
	;[Block] Transferdaten speichern
	;datei-transfers-zhen
	LAMA_CountTransfers=0
	For LAMA_Transfer.LAMA_Transfer=Each LAMA_Transfer
		LAMA_CountTransfers=LAMA_CountTransfers+1
	Next
	Dim LAMA_TransferMode(LAMA_CountTransfers%)
	Dim LAMA_TransferName$(LAMA_CountTransfers%)
	Dim LAMA_TransferEnding$(LAMA_CountTransfers%)
	Dim LAMA_TransferFileName$(LAMA_CountTransfers%)
	Dim LAMA_TransferPath$(LAMA_CountTransfers%)
	Dim LAMA_TransferSize%(LAMA_CountTransfers%)
	Dim LAMA_TransferProgress#(LAMA_CountTransfers%)
	Dim LAMA_TransferHandle%(LAMA_CountTransfers)
	i=1
	For LAMA_Transfer.LAMA_Transfer=Each LAMA_Transfer
		LAMA_TransferMode(i)=LAMA_Transfer\SendOrRecv
		LAMA_TransferName$(i)=LAMA_Transfer\Name$
		LAMA_TransferEnding$(i)=LAMA_Transfer\Ending$
		LAMA_TransferFileName$(i)=LAMA_Transfer\Name$+"."+LAMA_Transfer\Ending$
		LAMA_TransferPath$(i)=LAMA_Transfer\Path$
		LAMA_TransferSize%(i)=LAMA_Transfer\Bytes
		LAMA_TransferProgress#(i)=LAMA_Transfer\Progress#
		LAMA_TransferHandle(i)=Handle(LAMA_Transfer.LAMA_Transfer)
		i=i+1
	Next
	;[End Block]
	;[Block] Serverlist
	;serverliste-erneuern
	Local LAMA_Info.LAMA_Information
	If LAMA_Counting%=True Then
		Select LAMA_Internet
			Case 0
				If LAMA_DefaultStream%>0 Then
					Local LAMA_ServerFound%=False
					While RecvUDPMsg(LAMA_DefaultStream%)
						LAMA_Tag=ReadByte(LAMA_DefaultStream%)
						Select LAMA_Tag
							Case 1;tag-request-antwort
								LAMA_ServerFound%=False
								ServerCode%=ReadInt(LAMA_DefaultStream%)
								ServerBannedFrom%=ReadByte(LAMA_DefaultStream%)
								ServerName$=ReadString(LAMA_DefaultStream%)
								ServerPlayers%=ReadInt(LAMA_DefaultStream%)
								ServerMaxPlayers%=ReadInt(LAMA_DefaultStream%)
								ServerLocked%=ReadByte(LAMA_DefaultStream%)
								ServerPassword%=ReadByte(LAMA_DefaultStream%)
								ServerPublisher$=ReadString(LAMA_DefaultStream%)					
								For Index=1 To LAMA_MaxServers%
									If LAMA_CountServerCode%(Index-1)=ServerCode% Then LAMA_ServerFound%=True
								Next
								If LAMA_ServerFound%=False And LAMA_CountServers%<LAMA_MaxServers% Then
									;Lama-server-in-dim-liste-abspeichern
									LAMA_CountServerIP%(LAMA_CountServers)=UDPMsgIP(LAMA_DefaultStream%)
									LAMA_CountServerPing%(LAMA_CountServers)=MilliSecs()-LAMA_CountMS%
									LAMA_CountServerCode%(LAMA_CountServers)=ServerCode%
									LAMA_CountServerName$(LAMA_CountServers)=ServerName$
									LAMA_CountServerLocked%(LAMA_CountServers)=ServerLocked%
									LAMA_CountServerPlayers%(LAMA_CountServers)=ServerPlayers%
									LAMA_CountServerPassword%(LAMA_CountServers)=ServerPassword%
									LAMA_CountServerMaxPlayers%(LAMA_CountServers)=ServerMaxPlayers%
									LAMA_CountServerBannedFrom%(LAMA_CountServers)=ServerBannedFrom%
									LAMA_CountServerPublisher$(LAMA_CountServers)=ServerPublisher$
									LAMA_Info.LAMA_Information=Object.LAMA_Information(LAMA_CountServerInformation(LAMA_CountServers))
									For i=0 To 9
										LAMA_VarType=ReadByte(LAMA_DefaultStream%)
										Select LAMA_VarType
											Case 1
												LAMA_Info\Information[i]=ReadByte(LAMA_DefaultStream%)
											Case 2
												LAMA_Info\Information[i]=ReadShort(LAMA_DefaultStream%)
											Case 3
												LAMA_Info\Information[i]=ReadInt(LAMA_DefaultStream%)
											Case 4
												LAMA_Info\Information[i]=ReadFloat(LAMA_DefaultStream%)
											Case 5
												LAMA_Info\Information[i]=ReadString(LAMA_DefaultStream%)
											Case 6
												LAMA_Info\Information[i]=-ReadByte(LAMA_DefaultStream%)
											Case 7
												LAMA_Info\Information[i]=-ReadShort(LAMA_DefaultStream%)
											Case 8
												LAMA_Info\Information[i]=-ReadInt(LAMA_DefaultStream%)
										End Select
									Next
									LAMA_CountServers%=LAMA_CountServers%+1
								Else;wenn-serveranzahl-gleich-maximaler-suchanzahl
									For i=0 To 9
										LAMA_VarType=ReadByte(LAMA_DefaultStream%)
										Select LAMA_VarType
											Case 1
												ReadByte(LAMA_DefaultStream%)
											Case 2
												ReadShort(LAMA_DefaultStream%)
											Case 3
												ReadInt(LAMA_DefaultStream%)
											Case 4
												ReadFloat(LAMA_DefaultStream%)
											Case 5
												ReadString(LAMA_DefaultStream%)
											Case 6
												ReadByte(LAMA_DefaultStream%)
											Case 7
												ReadShort(LAMA_DefaultStream%)
											Case 8
												ReadInt(LAMA_DefaultStream%)
										End Select
									Next
								EndIf
						End Select
					Wend
				EndIf
			Case 1
				If LAMA_MasterServerStream<>0 Then
					If Eof(LAMA_MasterServerStream)=0 Then
						For i=1 To 7
							ReadLine(LAMA_MasterServerStream)
						Next
					EndIf
					Local FirstLine$=ReadLine(LAMA_MasterServerStream)
					While Eof(LAMA_MasterServerStream)=0
						LAMA_Info.LAMA_Information=Object.LAMA_Information(LAMA_CountServerInformation(LAMA_CountServers))
						LAMA_CountServerIP%(LAMA_CountServers)=FirstLine$
						LAMA_CountServerPort%(LAMA_CountServers)=ReadLine(LAMA_MasterServerStream)
						ServerName$=ReadLine(LAMA_MasterServerStream)
						ServerPublisher$=ReadLine(LAMA_MasterServerStream)
						ServerPlayers%=ReadLine(LAMA_MasterServerStream)
						ServerMaxPlayers%=ReadLine(LAMA_MasterServerStream)
						ServerLocked%=ReadLine(LAMA_MasterServerStream)
						ServerPassword%=ReadLine(LAMA_MasterServerStream)
						
						ReadLine(LAMA_MasterServerStream)
						FirstLine$=ReadLine(LAMA_MasterServerStream)
						;For i=0 To 9
						;	LAMA_Info\Information[i]=ReadLine(LAMA_MasterServerStream)
						;Next
						;Lama-server-in-dim-liste-abspeichern
						LAMA_CountServerPing%(LAMA_CountServers)=MilliSecs()-LAMA_CountMS%
						LAMA_CountServerCode%(LAMA_CountServers)=0
						LAMA_CountServerName$(LAMA_CountServers)=ServerName$
						LAMA_CountServerLocked%(LAMA_CountServers)=ServerLocked%
						LAMA_CountServerPlayers%(LAMA_CountServers)=ServerPlayers%
						LAMA_CountServerPassword%(LAMA_CountServers)=ServerPassword%
						LAMA_CountServerMaxPlayers%(LAMA_CountServers)=ServerMaxPlayers%
						;LAMA_CountServerBannedFrom%(LAMA_CountServers)=ServerBannedFrom%
						LAMA_CountServerPublisher$(LAMA_CountServers)=ServerPublisher$
						LAMA_CountServers%=LAMA_CountServers%+1
						If FirstLine$="" Then Exit
					Wend
				EndIf
		End Select
	EndIf
	;[End Block]
	
	;nachrichten-werte-zuruecksetzen
	LAMA_From%=0
	LAMA_MsgID%=0
	LAMA_GadgetID%=0
	
End Function

Function LAMA_TransferMB#(FileIndex%)
	Local Bytes=LAMA_TransferSize%(FileIndex%)
	Local MB#=Float(Bytes)/(1000.0*1024.0)
	If MB#<1 Then
		Return MB#
	Else
		Return Float(Bytes)/(1024.0*1024.0)
	EndIf
End Function

Function LAMA_CloseServer%()
	
	
	Local LAMA_ID%
	If LAMA_Connection Then
		Select LAMA_Mode%
			Case LAMA_Host%
				For LAMA_ID%=1 To LAMA_ServerMaxPlayers%
					If LAMA_ID%<>LAMA_MasterID And LAMA_PlayerOnline%(LAMA_ID%-1)=1 Then
						WriteByte LAMA_ServerStream%,11
						SendUDPMsg LAMA_ServerStream%,LAMA_PlayerIP%(LAMA_ID%-1),LAMA_PlayerPort%(LAMA_ID%-1)
					EndIf
					LAMA_PlayerOnline%(LAMA_ID%-1)=0
				Next
				If LAMA_ServerStream%>0 Then CloseUDPStream(LAMA_ServerStream%):LAMA_ServerStream%=0
				If LAMA_Internet=1 And LAMA_MasterServerStream<>0 Then
					CloseTCPStream(LAMA_MasterServerStream)
				EndIf
				Dim LAMA_PlayerOnline%(0)
				Dim LAMA_PlayerStream%(0)
				Dim LAMA_PlayerPingOK%(0)
				Dim LAMA_PlayerPing%(0)
				Dim LAMA_PlayerMS%(0)
				LAMA_Connection%=False
				LAMA_ServerMaxPlayers%=0
			Case LAMA_Client%
				WriteByte LAMA_ServerStream%,3
				WriteInt LAMA_ServerStream%,LAMA_MasterID
				SendUDPMsg LAMA_ServerStream%,LAMA_ServerIP%,LAMA_ServerPort%
				;UDP-stream-schliessen
				If LAMA_ServerStream%>0 Then CloseUDPStream(LAMA_ServerStream%):LAMA_ServerStream%=0
				For LAMA_ID%=1 To LAMA_ServerMaxPlayers%
					LAMA_PlayerOnline%(LAMA_ID%-1)=0
				Next
				LAMA_Connection%=False
				LAMA_ServerMaxPlayers%=0
		End Select
	EndIf
	
	
	
End Function

Function LAMA_LockServer()
	If LAMA_Mode%=LAMA_Host% Then LAMA_HostServerLocked%=True
End Function
Function LAMA_UnLockServer()
	If LAMA_Mode%=LAMA_Host% Then LAMA_HostServerLocked%=False
End Function

Function LAMA_RenameServer(ServerName$)
	
	ServerName$=Left(ServerName$,LAMA_MaxCharacters)
	Local LAMA_ID%
	If LAMA_Connection% And LAMA_Mode%=LAMA_Host% Then
		LAMA_ServerName$=ServerName$
		If LAMA_Internet=1 And LAMA_MasterServerStream<>0 Then
			;TCP-umbenennen
			Local Command$="Servername="+ServerName$
			WriteLine LAMA_MasterServerStream,"POST /Lama/UpdateServer.php HTTP/1.1"
			WriteLine LAMA_MasterServerStream,"Host: "+LAMA_MasterServerDetail$
			WriteLine LAMA_MasterServerStream,"User-Agent: LamaNet"
			WriteLine LAMA_MasterServerStream,"Content-Type: application/x-www-form-urlencoded" 
			WriteLine LAMA_MasterServerStream,"Content-Length: "+Len(Command$)
			
			WriteLine LAMA_MasterServerStream,"Keep-Alive: 115"
			WriteLine LAMA_MasterServerStream,"Connection: keep-alive"
			WriteLine LAMA_MasterServerStream,"Cache-Control: no-cache"
			WriteLine LAMA_MasterServerStream,""
			WriteLine LAMA_MasterServerStream,Command$
		EndIf
		;info-an-andere-spieler
		For LAMA_ID%=1 To LAMA_ServerMaxPlayers%
			If LAMA_PlayerOnline%(LAMA_ID%-1)=1 And LAMA_ID%<>LAMA_MasterID Then
				WriteByte(LAMA_ServerStream%,80)
				WriteString(LAMA_ServerStream%,LAMA_ServerName$)
				SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP%(LAMA_ID%-1),LAMA_PlayerPort%(LAMA_ID%-1))
			EndIf
		Next
	EndIf
	
	
End Function

;server-count-funktionen
Function LAMA_ServerName$(ServerID%=0)
	If ServerID%=0 Then
		Return LAMA_ServerName$
	Else If ServerID%>0 Then
		Return LAMA_CountServerName$(ServerID%-1)
	EndIf
End Function
Function LAMA_ServerPing%(ServerID%=0)
	If ServerID%=0 Then
		Return LAMA_PlayerPing(LAMA_ServerID%-1)
	Else If ServerID%>0 Then
		Return LAMA_CountServerPing%(ServerID%-1)
	EndIf
End Function
Function LAMA_ServerPlayers%(ServerID%=0)
	If ServerID%=0 Then
		Return LAMA_ServerPlayers%
	Else If ServerID%>0 Then
		Return LAMA_CountServerPlayers%(ServerID%-1)
	EndIf
End Function
Function LAMA_ServerMaxPlayers%(ServerID%=0)
	If ServerID%=0 Then
		Return LAMA_ServerMaxPlayers%
	Else If ServerID%>0 Then
		Return LAMA_CountServerMaxPlayers%(ServerID%-1)
	EndIf
End Function
Function LAMA_ServerLocked%(ServerID%=0)
	If ServerID%=0 Then
		Return LAMA_ServerLocked%
	Else If ServerID%>0 Then
		Return LAMA_CountServerLocked%(ServerID%-1)
	EndIf
End Function
Function LAMA_ServerPassword%(ServerID%=0)
	If ServerID%=0 Then
		Return LAMA_ServerPassword%
	Else If ServerID%>0 Then
		Return LAMA_CountServerPassword%(ServerID%-1)
	EndIf
End Function
Function LAMA_ServerBannedFrom%(ServerID%=0)
	If ServerID%=0 Then
		Return LAMA_ServerBannedFrom%
	Else If ServerID%>0 Then
		Return LAMA_CountServerBannedFrom%(ServerID%-1)
	EndIf
End Function
Function LAMA_ServerPublisher$(ServerID%=0)
	If ServerID%=0 Then
		Return LAMA_ServerPublisher$
	Else If ServerID%>0 Then
		Return LAMA_CountServerPublisher$(ServerID%-1)
	EndIf
End Function
Function LAMA_ServerInformation$(ServerID%=0,InfoID%=1)
	If ServerID%=0 Then
		Return LAMA_ServerInfo$(InfoID%-1)
	Else If ServerID%>0 Then
		Local LAMA_Info.LAMA_Information=Object.LAMA_Information(LAMA_CountServerInformation(ServerID%-1))
		Return LAMA_Info\Information[InfoID%-1]
	EndIf
End Function
Function LAMA_SetServerInformation(InfoID%=1,Information$)
	LAMA_ServerInfo(InfoID%-1)=Information$
	;an alle anderen spieler senden (aktualisieren)
	Local LAMA_ID%
	If LAMA_Connection% And LAMA_Mode%=LAMA_Host% Then
		For LAMA_ID%=1 To LAMA_ServerMaxPlayers%
			If LAMA_PlayerOnline%(LAMA_ID%-1)=1 And LAMA_ID%<>LAMA_MasterID Then
				WriteByte(LAMA_ServerStream%,81)
				WriteByte(LAMA_ServerStream%,InfoID%)
				WriteString(LAMA_ServerStream%,Information$)
				SendUDPMsg(LAMA_ServerStream%,LAMA_PlayerIP%(LAMA_ID%-1),LAMA_PlayerPort%(LAMA_ID%-1))
			EndIf
		Next
	EndIf
End Function

Function LAMA_StartCountServers%(MaxServers%=100)
	
	
	LAMA_CountServers%=0
	LAMA_MaxServers%=MaxServers%
	Dim LAMA_CountServerIP%(LAMA_MaxServers%-1)
	Dim LAMA_CountServerPort%(LAMA_MaxServers%-1)
	Dim LAMA_CountServerPing%(LAMA_MaxServers%-1)
	Dim LAMA_CountServerCode%(LAMA_MaxServers%-1)
	Dim LAMA_CountServerName$(LAMA_MaxServers%-1)
	Dim LAMA_CountServerLocked%(LAMA_MaxServers%-1)
	Dim LAMA_CountServerPlayers%(LAMA_MaxServers%-1)
	Dim LAMA_CountServerPassword%(LAMA_MaxServers%-1)
	Dim LAMA_CountServerMaxPlayers%(LAMA_MaxServers%-1)
	Dim LAMA_CountServerBannedFrom%(LAMA_MaxServers%-1)
	Dim LAMA_CountServerPublisher$(LAMA_MaxServers%-1)
	Dim LAMA_CountServerInformation%(LAMA_MaxServers%-1)
	;Variablen-vorbereiten
	Local Index
	;Anfrage-via-broadcastIP-senden
	LAMA_DefaultStream%=CreateUDPStream()
	If LAMA_DefaultStream%=0 Then Return 0
	;Anfrage-absenden
	If  LAMA_Internet=0 Then BroadCastIP()
	Local LAMA_Info.LAMA_Information
	For LAMA_Info.LAMA_Information=Each LAMA_Information
		Delete LAMA_Info
	Next
	For Index=0 To 9
		LAMA_Info.LAMA_Information=New LAMA_Information
		LAMA_CountServerInformation%(Index)=Handle(LAMA_Info.LAMA_Information)
	Next
	Select LAMA_Internet
		Case 0
			For Index=1 To LAMA_BroadCastIPs%
				WriteByte LAMA_DefaultStream%,1
				SendUDPMsg LAMA_DefaultStream%,LAMA_BroadCastIP%(Index-1),LAMA_ServerPort%
			Next
		Case 1
			LAMA_MasterServerStream=OpenTCPStream(LAMA_MasterServerDetail,LAMA_MasterServerPort)
			If LAMA_MasterServerStream<>0 Then
				WriteLine LAMA_MasterServerStream,"GET /Lama/ListServers.php HTTP/1.1"
				WriteLine LAMA_MasterServerStream,"Host: "+LAMA_MasterServerDetail$
				WriteLine LAMA_MasterServerStream,"User-Agent: LamaNet"
				WriteLine LAMA_MasterServerStream,""
			Else
				Return 0
			EndIf
	End Select
	
	LAMA_CountMS%=MilliSecs()
	LAMA_Counting%=True
	Return 1
	
	
End Function
Function LAMA_SendCountRequest()
	Local Index
	
	If LAMA_DefaultStream%>0 Then
		;Speicherfelder-zurcksetzen
		LAMA_CountServers%=0
		Dim LAMA_CountServerIP%(LAMA_MaxServers%-1)
		Dim LAMA_CountServerPort%(LAMA_MaxServers%-1)
		Dim LAMA_CountServerPing%(LAMA_MaxServers%-1)
		Dim LAMA_CountServerCode%(LAMA_MaxServers%-1)
		Dim LAMA_CountServerName$(LAMA_MaxServers%-1)
		Dim LAMA_CountServerLocked%(LAMA_MaxServers%-1)
		Dim LAMA_CountServerPlayers%(LAMA_MaxServers%-1)
		Dim LAMA_CountServerPassword%(LAMA_MaxServers%-1)
		Dim LAMA_CountServerMaxPlayers%(LAMA_MaxServers%-1)
		Dim LAMA_CountServerBannedFrom%(LAMA_MaxServers%-1)
		Dim LAMA_CountServerPublisher$(LAMA_MaxServers%-1)
		Dim LAMA_CountServerInformation%(LAMA_MaxServers%-1)
		Local LAMA_Info.LAMA_Information
		For LAMA_Info.LAMA_Information=Each LAMA_Information
			Delete LAMA_Info
		Next
		For Index=0 To 9
			LAMA_Info.LAMA_Information=New LAMA_Information
			LAMA_CountServerInformation%(Index)=Handle(LAMA_Info.LAMA_Information)
		Next
		Select LAMA_Internet
			Case 0
				For Index=1 To LAMA_BroadCastIPs%
					WriteByte LAMA_DefaultStream%,1
					SendUDPMsg LAMA_DefaultStream%,LAMA_BroadCastIP%(Index-1),LAMA_ServerPort%
				Next
			Case 1
				If LAMA_MasterServerStream<>0 Then
					WriteLine LAMA_MasterServerStream,"GET /Lama/ListServers.php HTTP/1.1"
					WriteLine LAMA_MasterServerStream,"Host: "+LAMA_MasterServerDetail$
					WriteLine LAMA_MasterServerStream,"User-Agent: LamaNet"
					WriteLine LAMA_MasterServerStream,""
				EndIf
		End Select
	EndIf
	
End Function
Function LAMA_StopCountServers%()
	;schliesst-UDP/TCP-stream
	If LAMA_DefaultStream%>0 Then CloseUDPStream(LAMA_DefaultStream%):LAMA_DefaultStream%=0
	If LAMA_MasterServerStream<>0 Then CloseTCPStream(LAMA_MasterServerStream):LAMA_MasterServerStream=0
	LAMA_Counting%=False
End Function

;Intern
Function LAMA_CleanBank(Bank%)
	Local Index%
	Local NBank%=CreateBank(0)
	For Index=0 To BankSize(Bank%)/4-1
		PeekInt(Bank%,Index*4)
		If PeekInt(Bank%,Index*4)<>0 Then
			ResizeBank(NBank%,BankSize(NBank%)+4)
			PokeInt NBank%,BankSize(NBank%)-4,PeekInt(Bank%,Index*4)
		EndIf
	Next
	FreeBank Bank%
	Return NBank%
End Function
Function LAMA_FileInformation(Path$)
	LAMA_FileName$=""
	LAMA_FileEnding$=""
	Local Ending$=Right(Path$,5),i
	For i=1 To 5
		If Mid(Ending,6-i,1)="." Then
			LAMA_FileEnding$=Mid(Ending,7-i,-1)
			Exit
		EndIf
	Next
	For i=1 To Len(Path$)
		If Mid(Path$,Len(Path$)+1-i,1)="\" Or Mid(Path$,Len(Path$)+1-i,1)="/" Then
			LAMA_FileName$=Mid(Path$,Len(Path$)+2-i,-1)
			LAMA_FileName$=Replace(LAMA_FileName$,"."+LAMA_FileEnding$,"")
			Exit
		EndIf
	Next
	If LAMA_FileName$="" Then LAMA_FileName$=Replace(Path$,"."+LAMA_FileEnding$,"")
End Function
Function LAMA_Identify(Value$)
	Local IntValue=Int(Value$)
	If Value$<>"" Then
		If Str(IntValue)=Value$ Then
			If IntValue>=0 Then
				If IntValue<256 Then
					Return 1
				Else If IntValue<65536 Then
					Return 2
				Else
					Return 3
				EndIf
			Else
				If Abs(IntValue)<256 Then
					Return 6
				Else If Abs(IntValue)<65536 Then
					Return 7
				Else
					Return 8
				EndIf
			EndIf
		Else If Str(Float(Value$))=Value$ Then
			Return 4
		Else
			Return 5
		EndIf
	Else
		Return 5
	EndIf
End Function
Function BroadCastIP(DelayTime=1000)
	Local index,LAMA_txt$,SubMask$
	Local IPs%=CountHostIPs(GetEnv("localhost"))
	
	LAMA_BroadCastIPs%=0
	
	Dim LAMA_IP%(IPs%-1)
	Dim LAMA_DotIP$(IPs%-1)
	Dim LAMA_BroadCastIP%(IPs%-1)
	
	For index=1 To IPs%
		LAMA_IP%(index-1)=HostIP(index)
		LAMA_DotIP$(index-1)=DottedIP(HostIP(index))
	Next
	
	Local path$=GetEnv("appdata")+"\"
	Local ipconfig=WriteFile(path$+"temp.bat")
	WriteLine ipconfig,"ipconfig > "+Chr(34)+path$+"ipconfig.txt"+Chr(34)
	CloseFile ipconfig
	LAMA_Shell%(0,"open",path$+"temp.bat","","",0)
	Delay DelayTime
	DeleteFile path$+"temp.bat"
	For index=1 To IPs%
		ipconfig=ReadFile(path$+"ipconfig.txt")
		While Not Eof(ipconfig)
			LAMA_txt$=ReadLine(ipconfig)
			If Instr(LAMA_txt$,LAMA_DotIP$(index-1)) Then
				LAMA_txt$=ReadLine(ipconfig)
				SubMask$=Right(LAMA_txt$,Len(LAMA_txt$)-Instr(LAMA_txt$,":")-1)
				CountHostIPs(SubMask$)
				LAMA_BroadCastIP%(index-1)=INT_IP(LAMA_IP%(index-1) Or (~HostIP(1)))
				LAMA_BroadCastIPs%=LAMA_BroadCastIPs%+1
			EndIf
		Wend
		CloseFile ipconfig
	Next
	DeleteFile path$+"ipconfig.txt"
	Return LAMA_BroadCastIPs%
End Function
Function INT_IP%(IP$)
	Local P1=Instr(IP$,".")
	Local P2=Instr(IP$,".",P1+1)
	Local P3=Instr(IP$,".",P2+1)
	Return (Int(Mid(IP$,1,P1))*16777216)+(Int(Mid(IP$,P1+1,P2-P1))*65536)+(Int(Mid(IP$,P2+1,P3-P2))*256)+Int(Mid(IP$,P3+1,-1))
End Function
Function LAMA_EnCode$(Password$)
	Local Code$,Code2$,S
	Local AscSum
	For S=1 To Len(Password$)
		AscSum=(AscSum+Asc(Mid(Password$,S,1))) Mod 35
	Next
	For S=1 To Len(Password$)
		Code$=Code$+Hex$(Sin(Asc(Mid(Password$,S,1))+AscSum+S*AscSum)*100000000+AscSum)
	Next
	For S=1 To Len(Code$)-4 Step 4
		Code2$=Code2$+Chr(((Int(Mid(Code$,S,4))+AscSum) Mod 95)+33)
	Next
	Return Code2$
End Function
Function LAMA_Pass%(Password$,PassCode$)
	If PassCode$=LAMA_EnCode$(Password$) Then Return 1
End Function

;type-felder
Type LAMA_Gadget
	Field GadgetID%
	Field Bank%,Bytes%,BankID%
	Field Name$,Path$,Ending$
End Type
Type LAMA_BanList
	Field IP%,MS%;speichert-ip-des-gebannten-spielers-und-ggf-bannzeit
End Type
Type LAMA_GetEvent
	Field ID%,PlayerID%,GadgetID%,Info$
End Type
Type LAMA_Transfer
	Field GadgetID%,ID%,File,FileID%
	Field Ending$,Name$,Path$,Bytes
	Field Progress#,PackageIndex
	Field SendAccess,MS%
	Field SendOrRecv;(1/2)
	Field Avail%
End Type
Type LAMA_Information
	Field Information$[9]
End Type
Type LAMA_SecureSend
	Field Tail,Value$,MsgID%
End Type
Type LAMA_NormalSend
	Field Tail,Value$,ID%,MsgID%
	Field MS%,SecureID%,SendAccess,Trys%
	Field Secure%
End Type
Type LAMA_MultiSend
	Field Tail,Value$,ID%,FromID%,MsgID%
End Type
Type LAMA_RecvMsg
	Field Value$,FromID%,MsgID%
End Type


;~IDEal Editor Parameters:
;~F#AF#D4#E6#FA#10A#117#11B#14D#169#1A3#1B7#1EB#211#226#229#22C#22F#234#243#24B
;~F#250#255#258#2BE#346#36F#3E0#626#756#7C8#80B#826#8AC#8B6#8E1#8E4#8E8#90B#912#919
;~F#920#927#92E#935#93C#943#94B#95B#993#9BE#9C6#9D3#9E6#A04#A2B#A31#A3F#A44#A49#A4C
;~F#A4F#A57#A5A#A5D#A62#A65
;~C#Blitz3D