SeedRnd MilliSecs()
Graphics3D 640,480,0,2
SetBuffer BackBuffer()

Local i%,MHit%,M.Message,P.Player
Local Direction%,File$

Global MaxPlayers%=5

Local Font=LoadFont("Verdana",12,0,0,0):SetFont Font

Include "LAmaNet.bb"


;3D-Umgebung
Local Textur=CreateTexture(128,128)
SetBuffer TextureBuffer(Textur)
Color 32,32,32
Rect 1,1,64,64
Rect 64,64,64,64
ScaleTexture Textur,4,4
SetBuffer BackBuffer()
Color 255,255,255

Local Plane=CreatePlane()
PositionEntity Plane,0,-1,0
EntityTexture Plane,Textur



Local C#=Rnd(0,1)
Local R=CColor(C#,1)
Local G=CColor(C#,2)
Local B=CColor(C#,3)
Local RTemp,GTemp,BTemp

Local Radius#=5.0
Local CameraFlow#=0.1,DX#,DY#,DZ#
Local Camera=CreateCamera()
PositionEntity Camera,0,4,-5
RotateEntity Camera,35,0,0
;Nebel
CameraFogMode Camera,1
CameraFogColor Camera,0,0,0
CameraFogRange Camera,5,50
;Licht
Local Light=CreateLight()
RotateEntity Light,50,70,0

;Spielersystem
Dim Player(MaxPlayers%);erster Type bleibt EInfachheitshalber frei (fr Fortgeschrittene einfach MaxPlayers%-1)
For i=1 To MaxPlayers%
	P.Player=New Player
	P\ID%=i
	P\Mesh%=CreateCube()
	P\CameraPivot%=CreatePivot(P\Mesh%):PositionEntity P\CameraPivot,0,4,-8
	P\AlignPivot%=CreatePivot(P\Mesh%):PositionEntity P\AlignPivot%,0,0,+6
	RotateEntity P\Mesh%,0,i*75,0
	PositionEntity P\Mesh%,Radius#*Cos(i*75),0,Radius#*Sin(i*75)
	EntityAlpha P\Mesh,0.5
	
	
	Player(i)=Handle(P.Player)
Next

Local ServerOrClient=Input("Server erstellen(1) - Server suchen(2)")
Select ServerOrClient
	Case 1
		If LAMA_HostServer("LAmaNet - Testserver",MaxPlayers%,"Lama")=0 Then End
	Case 2
		If LAMA_StartCountServers()=0 Then End
	Default
		End
End Select

Local Tact%,InputText$,Sign$
Local Timer=CreateTimer(60)


FlushKeys
While Not KeyHit(1)
	Cls
	
	MHit=MouseHit(1)
	LAMA_Update()
	
	While LAMA_Event()
		Select LAMA_EventID
			Case LAMA_Connected
				;Spieler-einstellungen
				P.Player=Object.Player(Player(LAMA_MasterID))
				EntityColor P\Mesh,R,G,B
				EntityAlpha P\Mesh,1
				;eigene-daten-senden
				LAMA_Send(0,20,R)
				LAMA_Send(0,20,G)
				LAMA_Send(0,20,B)
			Case LAMA_Joined;neuer-spieler-schickt-eigene-daten
				M.Message=New Message
				M\Message$="Spiel beigetreten"
			Case LAMA_NewPlayer;server-schickt-daten-der-spieler-an-neuen-spieler
				M.Message=New Message
				M\Message$=LAMA_Name(LAMA_EventPlayerID)+" beigetreten"
				;eigene-daten-senden
				LAMA_Send(LAMA_EventPlayerID,20,R)
				LAMA_Send(LAMA_EventPlayerID,20,G)
				LAMA_Send(LAMA_EventPlayerID,20,B)
			Case LAMA_CountRequest;server-erhlt-counter-server-request
				M.Message=New Message
				M\Message$="Clientanfrage erhalten"
			Case LAMA_ServerFull;pc-erhlt-server-full-information
				M.Message=New Message
				M\Message$="Server voll"
			Case LAMA_PlayerLeft%
				M.Message=New Message
				M\Message$="Spieler "+LAMA_Name(LAMA_EventPlayerID)+" hat das Spiel verlassen."
				;daten-des-spielers-zurcksetzen
				P.Player=Object.Player(Player(LAMA_EventPlayerID))
				EntityColor P\Mesh,255,255,255
				EntityAlpha P\Mesh,0.5
				RotateEntity P\Mesh%,0,P\ID%*75,0
				PositionEntity P\Mesh%,Radius#*Cos(P\ID%*75),0,Radius#*Sin(P\ID%*75)
			Case LAMA_ServerLeft%
				M.Message=New Message
				M\Message$="Server hat das spiel verlassen - Verbindung getrennt!"
		End Select
	Wend
	
	If LAMA_Connection Then;wenn-verbindung-noch-nicht-hergestellt
		P.Player=Object.Player(Player(LAMA_MasterID))
		
		;Camera-und-Objekt-bewegen
		DX#=(EntityX(P\CameraPivot,1)-EntityX(Camera,1))*CameraFlow#
		DY#=(EntityY(P\CameraPivot,1)-EntityY(Camera,1))*CameraFlow#
		DZ#=(EntityZ(P\CameraPivot,1)-EntityZ(Camera,1))*CameraFlow#
		TranslateEntity Camera,DX#,DY#,DZ#
		DX#=EntityX(P\AlignPivot,1)-EntityX(Camera,1)
		DY#=EntityY(P\AlignPivot,1)-EntityY(Camera,1)
		DZ#=EntityZ(P\AlignPivot,1)-EntityZ(Camera,1)
		AlignToVector Camera,DX#,DY#,DZ#,3,CameraFlow#
		If KeyDown(200) Then P\Speed#=P\Speed#+0.01
		If KeyDown(208) Then P\Speed#=P\Speed#-0.01
		If KeyDown(203) Then P\RSpeed#=P\RSpeed#+0.1
		If KeyDown(205) Then P\RSpeed#=P\RSpeed#-0.1
		P\Speed#=P\Speed#*0.95
		P\RSpeed#=P\RSpeed#*0.95
		MoveEntity P\Mesh,0,0,P\Speed#
		TurnEntity P\Mesh,0,P\RSpeed#,0
		TurnEntity Camera,0,0,-EntityRoll(Camera)*CameraFlow#
		;daten-senden
		LAMA_Send(0,1,EntityX(P\Mesh))
		LAMA_Send(0,1,EntityY(P\Mesh))
		LAMA_Send(0,1,EntityZ(P\Mesh))
		LAMA_Send(0,1,EntityYaw(P\Mesh))
		
		;empfangsschleife
		While LAMA_Recv()
			P.Player=Object.Player(LAMA_From)
			Select LAMA_MsgID
				Case 1
					P\X=LAMA_Read()
					P\Y=LAMA_Read()
					P\Z=LAMA_Read()
					PositionEntity P\Mesh,P\X,P\Y,P\Z
					RotateEntity P\Mesh,0,LAMA_Read(),0
				Case 20
					RTemp=LAMA_Read()
					GTemp=LAMA_Read()
					BTemp=LAMA_Read()
					EntityColor P\Mesh,RTemp,GTemp,BTemp
					EntityAlpha P\Mesh,1
			End Select
		Wend
		
		RenderWorld()
		
		;Spieler-anzeige
		For P.Player=Each Player
			If LAMA_Online(P\ID%) Then
				CameraProject Camera,EntityX(P\Mesh),EntityY(P\Mesh)+2.5,EntityZ(P\Mesh)
				If ProjectedZ()>0 Then
					Text ProjectedX(),ProjectedY(),LAMA_Name(P\ID),1
					Text ProjectedX(),ProjectedY()+12,"Ping: "+LAMA_Ping(P\ID),1
				EndIf
			Else
				CameraProject Camera,EntityX(P\Mesh),EntityY(P\Mesh)+2.5,EntityZ(P\Mesh)
				If ProjectedZ()>0 Then
					Text ProjectedX(),ProjectedY(),"Offline",1
				EndIf
			EndIf
		Next
		Text GraphicsWidth()-10,0,LAMA_MasterID
		
		Color 255,255,255
		Select LAMA_Mode
			Case 1;Server-schleife
				Text 0,0,"Server geffnet"
			Case 2;Client-schleife
				If RectsOverlap(GraphicsWidth()-9,0,9,9,MouseX(),MouseY(),1,1) Then
					Color 0,255,0
					If MHit Then
						LAMA_CloseServer()
					EndIf
				Else
					Color 255,255,255
				EndIf
				Rect GraphicsWidth()-9,0,9,9,0
				Line GraphicsWidth()-9,0,GraphicsWidth(),10
				Line GraphicsWidth(),0,GraphicsWidth()-9,8
		End Select
		
	Else;verbindung-nicht-hergestellt
		Color 255,255,255
		Text 0,0,"erstelle Serverlist..."
		Text GraphicsWidth()/2,50,"Serverlist:",1
		For i=1 To LAMA_CountServers
			Text GraphicsWidth()/2,50+i*12,LAMA_ServerName$(i)+"("+LAMA_ServerPlayers(i)+"/"+LAMA_ServerMaxPlayers(i)+")"
			;Button
			If RectsOverlap(GraphicsWidth()/2-200,50+i*12,150,12,MouseX(),MouseY(),1,1) Then
				Color 0,255,0
				If MHit Then
					LAMA_JoinServer(i,"JoinLama")
				EndIf
			Else
				Color 255,255,255
			EndIf
			Text GraphicsWidth()/2-125,50+i*12,"Login",1,0
			Rect GraphicsWidth()/2-200,50+i*12,150,12,0
			Color 255,255,255
			;EndButton
		Next
		;Reloadbutton
		If RectsOverlap(0,GraphicsHeight()-12,150,12,MouseX(),MouseY(),1,1) Then
			Color 0,255,0
			If MHit Then LAMA_SendCountRequest()
		Else
			Color 255,255,255
		EndIf
		Text 75,GraphicsHeight()-12,"Reload",1,0
		Rect 0,GraphicsHeight()-12,150,15,0
		Color 255,255,255
	EndIf
	
	;Nachrichtenanzeige
	i=0
	For M.Message=Each Message
		Text 0,12+i*12,M\Message$
		i=i+1
		M\Count=M\Count+1
		If M\Count=1800 Then Delete M.Message
	Next
	
	WaitTimer Timer
	Flip 0
Wend
LAMA_CloseServer()
End

Type Message
	Field Message$,Count%
End Type
Type Player
	Field ID%
	Field Mesh%,CameraPivot%,AlignPivot%,X#,Y#,Z#,Speed#,RSpeed#
	Field MDown,Klicks
End Type
Function CColor(C#,ReturnColor,Br#=1.0)
	Local R,G,B
	C#=C#*360 Mod 360
	Local CP#=(C# Mod 60)/60.0
	If C#=>000 And C#<060 Then
		R=255
		G=255*CP#
	ElseIf C#=>060 And C#<120
		R=255*(1-CP#)
		G=255
	ElseIf C#=>120 And C#<180
		G=255
		B=255*CP#
	ElseIf C#=>180 And C#<240
		G=255*(1-CP#)
		B=255
	ElseIf C#=>240 And C#<300
		R=255*CP#
		B=255
	ElseIf C#=>300 And C#<360
		R=255
		B=255*(1-CP#)
	EndIf
	If ReturnColor=1 Then Return R*Br#
	If ReturnColor=2 Then Return G*Br#
	If ReturnColor=3 Then Return B*Br#
End Function
;~IDEal Editor Parameters:
;~F#10A
;~C#Blitz3D